/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAwsMqBrokerEngineTypesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/mq_broker_engine_types#engine_type DataAwsMqBrokerEngineTypes#engine_type}
    */
    readonly engineType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/mq_broker_engine_types#id DataAwsMqBrokerEngineTypes#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersions {
}
export declare function dataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersionsToTerraform(struct?: DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersions): any;
export declare function dataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersionsToHclTerraform(struct?: DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersions): any;
export declare class DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersions | undefined;
    set internalValue(value: DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersions | undefined);
    get name(): string;
}
export declare class DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersionsOutputReference;
}
export interface DataAwsMqBrokerEngineTypesBrokerEngineTypes {
}
export declare function dataAwsMqBrokerEngineTypesBrokerEngineTypesToTerraform(struct?: DataAwsMqBrokerEngineTypesBrokerEngineTypes): any;
export declare function dataAwsMqBrokerEngineTypesBrokerEngineTypesToHclTerraform(struct?: DataAwsMqBrokerEngineTypesBrokerEngineTypes): any;
export declare class DataAwsMqBrokerEngineTypesBrokerEngineTypesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAwsMqBrokerEngineTypesBrokerEngineTypes | undefined;
    set internalValue(value: DataAwsMqBrokerEngineTypesBrokerEngineTypes | undefined);
    get engineType(): string;
    private _engineVersions;
    get engineVersions(): DataAwsMqBrokerEngineTypesBrokerEngineTypesEngineVersionsList;
}
export declare class DataAwsMqBrokerEngineTypesBrokerEngineTypesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAwsMqBrokerEngineTypesBrokerEngineTypesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/mq_broker_engine_types aws_mq_broker_engine_types}
*/
export declare class DataAwsMqBrokerEngineTypes extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "aws_mq_broker_engine_types";
    /**
    * Generates CDKTF code for importing a DataAwsMqBrokerEngineTypes resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAwsMqBrokerEngineTypes to import
    * @param importFromId The id of the existing DataAwsMqBrokerEngineTypes that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/mq_broker_engine_types#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAwsMqBrokerEngineTypes to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/mq_broker_engine_types aws_mq_broker_engine_types} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsMqBrokerEngineTypesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAwsMqBrokerEngineTypesConfig);
    private _brokerEngineTypes;
    get brokerEngineTypes(): DataAwsMqBrokerEngineTypesBrokerEngineTypesList;
    private _engineType?;
    get engineType(): string;
    set engineType(value: string);
    resetEngineType(): void;
    get engineTypeInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
