/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAwsVpcIpamPoolsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/vpc_ipam_pools#id DataAwsVpcIpamPools#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/vpc_ipam_pools#filter DataAwsVpcIpamPools#filter}
    */
    readonly filter?: DataAwsVpcIpamPoolsFilter[] | cdktf.IResolvable;
}
export interface DataAwsVpcIpamPoolsIpamPools {
}
export declare function dataAwsVpcIpamPoolsIpamPoolsToTerraform(struct?: DataAwsVpcIpamPoolsIpamPools): any;
export declare function dataAwsVpcIpamPoolsIpamPoolsToHclTerraform(struct?: DataAwsVpcIpamPoolsIpamPools): any;
export declare class DataAwsVpcIpamPoolsIpamPoolsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAwsVpcIpamPoolsIpamPools | undefined;
    set internalValue(value: DataAwsVpcIpamPoolsIpamPools | undefined);
    get addressFamily(): string;
    get allocationDefaultNetmaskLength(): number;
    get allocationMaxNetmaskLength(): number;
    get allocationMinNetmaskLength(): number;
    private _allocationResourceTags;
    get allocationResourceTags(): cdktf.StringMap;
    get arn(): string;
    get autoImport(): cdktf.IResolvable;
    get awsService(): string;
    get description(): string;
    get id(): string;
    get ipamScopeId(): string;
    get ipamScopeType(): string;
    get locale(): string;
    get poolDepth(): number;
    get publiclyAdvertisable(): cdktf.IResolvable;
    get sourceIpamPoolId(): string;
    get state(): string;
    private _tags;
    get tags(): cdktf.StringMap;
}
export declare class DataAwsVpcIpamPoolsIpamPoolsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAwsVpcIpamPoolsIpamPoolsOutputReference;
}
export interface DataAwsVpcIpamPoolsFilter {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/vpc_ipam_pools#name DataAwsVpcIpamPools#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/vpc_ipam_pools#values DataAwsVpcIpamPools#values}
    */
    readonly values: string[];
}
export declare function dataAwsVpcIpamPoolsFilterToTerraform(struct?: DataAwsVpcIpamPoolsFilter | cdktf.IResolvable): any;
export declare function dataAwsVpcIpamPoolsFilterToHclTerraform(struct?: DataAwsVpcIpamPoolsFilter | cdktf.IResolvable): any;
export declare class DataAwsVpcIpamPoolsFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAwsVpcIpamPoolsFilter | cdktf.IResolvable | undefined;
    set internalValue(value: DataAwsVpcIpamPoolsFilter | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataAwsVpcIpamPoolsFilterList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAwsVpcIpamPoolsFilter[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAwsVpcIpamPoolsFilterOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/vpc_ipam_pools aws_vpc_ipam_pools}
*/
export declare class DataAwsVpcIpamPools extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "aws_vpc_ipam_pools";
    /**
    * Generates CDKTF code for importing a DataAwsVpcIpamPools resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAwsVpcIpamPools to import
    * @param importFromId The id of the existing DataAwsVpcIpamPools that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/vpc_ipam_pools#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAwsVpcIpamPools to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/aws/5.47.0/docs/data-sources/vpc_ipam_pools aws_vpc_ipam_pools} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsVpcIpamPoolsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAwsVpcIpamPoolsConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipamPools;
    get ipamPools(): DataAwsVpcIpamPoolsIpamPoolsList;
    private _filter;
    get filter(): DataAwsVpcIpamPoolsFilterList;
    putFilter(value: DataAwsVpcIpamPoolsFilter[] | cdktf.IResolvable): void;
    resetFilter(): void;
    get filterInput(): cdktf.IResolvable | DataAwsVpcIpamPoolsFilter[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
