/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
export * as accessanalyzerAnalyzer from './accessanalyzer-analyzer';
export * as accessanalyzerArchiveRule from './accessanalyzer-archive-rule';
export * as accountAlternateContact from './account-alternate-contact';
export * as accountPrimaryContact from './account-primary-contact';
export * as accountRegion from './account-region';
export * as acmCertificate from './acm-certificate';
export * as acmCertificateValidation from './acm-certificate-validation';
export * as acmpcaCertificate from './acmpca-certificate';
export * as acmpcaCertificateAuthority from './acmpca-certificate-authority';
export * as acmpcaCertificateAuthorityCertificate from './acmpca-certificate-authority-certificate';
export * as acmpcaPermission from './acmpca-permission';
export * as acmpcaPolicy from './acmpca-policy';
export * as alb from './alb';
export * as albListener from './alb-listener';
export * as albListenerCertificate from './alb-listener-certificate';
export * as albListenerRule from './alb-listener-rule';
export * as albTargetGroup from './alb-target-group';
export * as albTargetGroupAttachment from './alb-target-group-attachment';
export * as ami from './ami';
export * as amiCopy from './ami-copy';
export * as amiFromInstance from './ami-from-instance';
export * as amiLaunchPermission from './ami-launch-permission';
export * as amplifyApp from './amplify-app';
export * as amplifyBackendEnvironment from './amplify-backend-environment';
export * as amplifyBranch from './amplify-branch';
export * as amplifyDomainAssociation from './amplify-domain-association';
export * as amplifyWebhook from './amplify-webhook';
export * as apiGatewayAccount from './api-gateway-account';
export * as apiGatewayApiKey from './api-gateway-api-key';
export * as apiGatewayAuthorizer from './api-gateway-authorizer';
export * as apiGatewayBasePathMapping from './api-gateway-base-path-mapping';
export * as apiGatewayClientCertificate from './api-gateway-client-certificate';
export * as apiGatewayDeployment from './api-gateway-deployment';
export * as apiGatewayDocumentationPart from './api-gateway-documentation-part';
export * as apiGatewayDocumentationVersion from './api-gateway-documentation-version';
export * as apiGatewayDomainName from './api-gateway-domain-name';
export * as apiGatewayGatewayResponse from './api-gateway-gateway-response';
export * as apiGatewayIntegration from './api-gateway-integration';
export * as apiGatewayIntegrationResponse from './api-gateway-integration-response';
export * as apiGatewayMethod from './api-gateway-method';
export * as apiGatewayMethodResponse from './api-gateway-method-response';
export * as apiGatewayMethodSettings from './api-gateway-method-settings';
export * as apiGatewayModel from './api-gateway-model';
export * as apiGatewayRequestValidator from './api-gateway-request-validator';
export * as apiGatewayResource from './api-gateway-resource';
export * as apiGatewayRestApi from './api-gateway-rest-api';
export * as apiGatewayRestApiPolicy from './api-gateway-rest-api-policy';
export * as apiGatewayStage from './api-gateway-stage';
export * as apiGatewayUsagePlan from './api-gateway-usage-plan';
export * as apiGatewayUsagePlanKey from './api-gateway-usage-plan-key';
export * as apiGatewayVpcLink from './api-gateway-vpc-link';
export * as apigatewayv2Api from './apigatewayv2-api';
export * as apigatewayv2ApiMapping from './apigatewayv2-api-mapping';
export * as apigatewayv2Authorizer from './apigatewayv2-authorizer';
export * as apigatewayv2Deployment from './apigatewayv2-deployment';
export * as apigatewayv2DomainName from './apigatewayv2-domain-name';
export * as apigatewayv2Integration from './apigatewayv2-integration';
export * as apigatewayv2IntegrationResponse from './apigatewayv2-integration-response';
export * as apigatewayv2Model from './apigatewayv2-model';
export * as apigatewayv2Route from './apigatewayv2-route';
export * as apigatewayv2RouteResponse from './apigatewayv2-route-response';
export * as apigatewayv2Stage from './apigatewayv2-stage';
export * as apigatewayv2VpcLink from './apigatewayv2-vpc-link';
export * as appCookieStickinessPolicy from './app-cookie-stickiness-policy';
export * as appautoscalingPolicy from './appautoscaling-policy';
export * as appautoscalingScheduledAction from './appautoscaling-scheduled-action';
export * as appautoscalingTarget from './appautoscaling-target';
export * as appconfigApplication from './appconfig-application';
export * as appconfigConfigurationProfile from './appconfig-configuration-profile';
export * as appconfigDeployment from './appconfig-deployment';
export * as appconfigDeploymentStrategy from './appconfig-deployment-strategy';
export * as appconfigEnvironment from './appconfig-environment';
export * as appconfigExtension from './appconfig-extension';
export * as appconfigExtensionAssociation from './appconfig-extension-association';
export * as appconfigHostedConfigurationVersion from './appconfig-hosted-configuration-version';
export * as appflowConnectorProfile from './appflow-connector-profile';
export * as appflowFlow from './appflow-flow';
export * as appintegrationsDataIntegration from './appintegrations-data-integration';
export * as appintegrationsEventIntegration from './appintegrations-event-integration';
export * as applicationinsightsApplication from './applicationinsights-application';
export * as appmeshGatewayRoute from './appmesh-gateway-route';
export * as appmeshMesh from './appmesh-mesh';
export * as appmeshRoute from './appmesh-route';
export * as appmeshVirtualGateway from './appmesh-virtual-gateway';
export * as appmeshVirtualNode from './appmesh-virtual-node';
export * as appmeshVirtualRouter from './appmesh-virtual-router';
export * as appmeshVirtualService from './appmesh-virtual-service';
export * as apprunnerAutoScalingConfigurationVersion from './apprunner-auto-scaling-configuration-version';
export * as apprunnerConnection from './apprunner-connection';
export * as apprunnerCustomDomainAssociation from './apprunner-custom-domain-association';
export * as apprunnerDefaultAutoScalingConfigurationVersion from './apprunner-default-auto-scaling-configuration-version';
export * as apprunnerDeployment from './apprunner-deployment';
export * as apprunnerObservabilityConfiguration from './apprunner-observability-configuration';
export * as apprunnerService from './apprunner-service';
export * as apprunnerVpcConnector from './apprunner-vpc-connector';
export * as apprunnerVpcIngressConnection from './apprunner-vpc-ingress-connection';
export * as appstreamDirectoryConfig from './appstream-directory-config';
export * as appstreamFleet from './appstream-fleet';
export * as appstreamFleetStackAssociation from './appstream-fleet-stack-association';
export * as appstreamImageBuilder from './appstream-image-builder';
export * as appstreamStack from './appstream-stack';
export * as appstreamUser from './appstream-user';
export * as appstreamUserStackAssociation from './appstream-user-stack-association';
export * as appsyncApiCache from './appsync-api-cache';
export * as appsyncApiKey from './appsync-api-key';
export * as appsyncDatasource from './appsync-datasource';
export * as appsyncDomainName from './appsync-domain-name';
export * as appsyncDomainNameApiAssociation from './appsync-domain-name-api-association';
export * as appsyncFunction from './appsync-function';
export * as appsyncGraphqlApi from './appsync-graphql-api';
export * as appsyncResolver from './appsync-resolver';
export * as appsyncType from './appsync-type';
export * as athenaDataCatalog from './athena-data-catalog';
export * as athenaDatabase from './athena-database';
export * as athenaNamedQuery from './athena-named-query';
export * as athenaPreparedStatement from './athena-prepared-statement';
export * as athenaWorkgroup from './athena-workgroup';
export * as auditmanagerAccountRegistration from './auditmanager-account-registration';
export * as auditmanagerAssessment from './auditmanager-assessment';
export * as auditmanagerAssessmentDelegation from './auditmanager-assessment-delegation';
export * as auditmanagerAssessmentReport from './auditmanager-assessment-report';
export * as auditmanagerControl from './auditmanager-control';
export * as auditmanagerFramework from './auditmanager-framework';
export * as auditmanagerFrameworkShare from './auditmanager-framework-share';
export * as auditmanagerOrganizationAdminAccountRegistration from './auditmanager-organization-admin-account-registration';
export * as autoscalingAttachment from './autoscaling-attachment';
export * as autoscalingGroup from './autoscaling-group';
export * as autoscalingGroupTag from './autoscaling-group-tag';
export * as autoscalingLifecycleHook from './autoscaling-lifecycle-hook';
export * as autoscalingNotification from './autoscaling-notification';
export * as autoscalingPolicy from './autoscaling-policy';
export * as autoscalingSchedule from './autoscaling-schedule';
export * as autoscalingTrafficSourceAttachment from './autoscaling-traffic-source-attachment';
export * as autoscalingplansScalingPlan from './autoscalingplans-scaling-plan';
export * as backupFramework from './backup-framework';
export * as backupGlobalSettings from './backup-global-settings';
export * as backupPlan from './backup-plan';
export * as backupRegionSettings from './backup-region-settings';
export * as backupReportPlan from './backup-report-plan';
export * as backupSelection from './backup-selection';
export * as backupVault from './backup-vault';
export * as backupVaultLockConfiguration from './backup-vault-lock-configuration';
export * as backupVaultNotifications from './backup-vault-notifications';
export * as backupVaultPolicy from './backup-vault-policy';
export * as batchComputeEnvironment from './batch-compute-environment';
export * as batchJobDefinition from './batch-job-definition';
export * as batchJobQueue from './batch-job-queue';
export * as batchSchedulingPolicy from './batch-scheduling-policy';
export * as bcmdataexportsExport from './bcmdataexports-export';
export * as bedrockCustomModel from './bedrock-custom-model';
export * as bedrockModelInvocationLoggingConfiguration from './bedrock-model-invocation-logging-configuration';
export * as bedrockProvisionedModelThroughput from './bedrock-provisioned-model-throughput';
export * as bedrockagentAgent from './bedrockagent-agent';
export * as bedrockagentAgentActionGroup from './bedrockagent-agent-action-group';
export * as bedrockagentAgentAlias from './bedrockagent-agent-alias';
export * as bedrockagentKnowledgeBase from './bedrockagent-knowledge-base';
export * as budgetsBudget from './budgets-budget';
export * as budgetsBudgetAction from './budgets-budget-action';
export * as ceAnomalyMonitor from './ce-anomaly-monitor';
export * as ceAnomalySubscription from './ce-anomaly-subscription';
export * as ceCostAllocationTag from './ce-cost-allocation-tag';
export * as ceCostCategory from './ce-cost-category';
export * as chimeVoiceConnector from './chime-voice-connector';
export * as chimeVoiceConnectorGroup from './chime-voice-connector-group';
export * as chimeVoiceConnectorLogging from './chime-voice-connector-logging';
export * as chimeVoiceConnectorOrigination from './chime-voice-connector-origination';
export * as chimeVoiceConnectorStreaming from './chime-voice-connector-streaming';
export * as chimeVoiceConnectorTermination from './chime-voice-connector-termination';
export * as chimeVoiceConnectorTerminationCredentials from './chime-voice-connector-termination-credentials';
export * as chimesdkmediapipelinesMediaInsightsPipelineConfiguration from './chimesdkmediapipelines-media-insights-pipeline-configuration';
export * as chimesdkvoiceGlobalSettings from './chimesdkvoice-global-settings';
export * as chimesdkvoiceSipMediaApplication from './chimesdkvoice-sip-media-application';
export * as chimesdkvoiceSipRule from './chimesdkvoice-sip-rule';
export * as chimesdkvoiceVoiceProfileDomain from './chimesdkvoice-voice-profile-domain';
export * as cleanroomsCollaboration from './cleanrooms-collaboration';
export * as cleanroomsConfiguredTable from './cleanrooms-configured-table';
export * as cloud9EnvironmentEc2 from './cloud9-environment-ec2';
export * as cloud9EnvironmentMembership from './cloud9-environment-membership';
export * as cloudcontrolapiResource from './cloudcontrolapi-resource';
export * as cloudformationStack from './cloudformation-stack';
export * as cloudformationStackSet from './cloudformation-stack-set';
export * as cloudformationStackSetInstance from './cloudformation-stack-set-instance';
export * as cloudformationType from './cloudformation-type';
export * as cloudfrontCachePolicy from './cloudfront-cache-policy';
export * as cloudfrontContinuousDeploymentPolicy from './cloudfront-continuous-deployment-policy';
export * as cloudfrontDistribution from './cloudfront-distribution';
export * as cloudfrontFieldLevelEncryptionConfig from './cloudfront-field-level-encryption-config';
export * as cloudfrontFieldLevelEncryptionProfile from './cloudfront-field-level-encryption-profile';
export * as cloudfrontFunction from './cloudfront-function';
export * as cloudfrontKeyGroup from './cloudfront-key-group';
export * as cloudfrontKeyValueStore from './cloudfront-key-value-store';
export * as cloudfrontMonitoringSubscription from './cloudfront-monitoring-subscription';
export * as cloudfrontOriginAccessControl from './cloudfront-origin-access-control';
export * as cloudfrontOriginAccessIdentity from './cloudfront-origin-access-identity';
export * as cloudfrontOriginRequestPolicy from './cloudfront-origin-request-policy';
export * as cloudfrontPublicKey from './cloudfront-public-key';
export * as cloudfrontRealtimeLogConfig from './cloudfront-realtime-log-config';
export * as cloudfrontResponseHeadersPolicy from './cloudfront-response-headers-policy';
export * as cloudfrontkeyvaluestoreKey from './cloudfrontkeyvaluestore-key';
export * as cloudhsmV2Cluster from './cloudhsm-v2-cluster';
export * as cloudhsmV2Hsm from './cloudhsm-v2-hsm';
export * as cloudsearchDomain from './cloudsearch-domain';
export * as cloudsearchDomainServiceAccessPolicy from './cloudsearch-domain-service-access-policy';
export * as cloudtrail from './cloudtrail';
export * as cloudtrailEventDataStore from './cloudtrail-event-data-store';
export * as cloudwatchCompositeAlarm from './cloudwatch-composite-alarm';
export * as cloudwatchDashboard from './cloudwatch-dashboard';
export * as cloudwatchEventApiDestination from './cloudwatch-event-api-destination';
export * as cloudwatchEventArchive from './cloudwatch-event-archive';
export * as cloudwatchEventBus from './cloudwatch-event-bus';
export * as cloudwatchEventBusPolicy from './cloudwatch-event-bus-policy';
export * as cloudwatchEventConnection from './cloudwatch-event-connection';
export * as cloudwatchEventEndpoint from './cloudwatch-event-endpoint';
export * as cloudwatchEventPermission from './cloudwatch-event-permission';
export * as cloudwatchEventRule from './cloudwatch-event-rule';
export * as cloudwatchEventTarget from './cloudwatch-event-target';
export * as cloudwatchLogDataProtectionPolicy from './cloudwatch-log-data-protection-policy';
export * as cloudwatchLogDestination from './cloudwatch-log-destination';
export * as cloudwatchLogDestinationPolicy from './cloudwatch-log-destination-policy';
export * as cloudwatchLogGroup from './cloudwatch-log-group';
export * as cloudwatchLogMetricFilter from './cloudwatch-log-metric-filter';
export * as cloudwatchLogResourcePolicy from './cloudwatch-log-resource-policy';
export * as cloudwatchLogStream from './cloudwatch-log-stream';
export * as cloudwatchLogSubscriptionFilter from './cloudwatch-log-subscription-filter';
export * as cloudwatchMetricAlarm from './cloudwatch-metric-alarm';
export * as cloudwatchMetricStream from './cloudwatch-metric-stream';
export * as cloudwatchQueryDefinition from './cloudwatch-query-definition';
export * as codeartifactDomain from './codeartifact-domain';
export * as codeartifactDomainPermissionsPolicy from './codeartifact-domain-permissions-policy';
export * as codeartifactRepository from './codeartifact-repository';
export * as codeartifactRepositoryPermissionsPolicy from './codeartifact-repository-permissions-policy';
export * as codebuildProject from './codebuild-project';
export * as codebuildReportGroup from './codebuild-report-group';
export * as codebuildResourcePolicy from './codebuild-resource-policy';
export * as codebuildSourceCredential from './codebuild-source-credential';
export * as codebuildWebhook from './codebuild-webhook';
export * as codecatalystDevEnvironment from './codecatalyst-dev-environment';
export * as codecatalystProject from './codecatalyst-project';
export * as codecatalystSourceRepository from './codecatalyst-source-repository';
export * as codecommitApprovalRuleTemplate from './codecommit-approval-rule-template';
export * as codecommitApprovalRuleTemplateAssociation from './codecommit-approval-rule-template-association';
export * as codecommitRepository from './codecommit-repository';
export * as codecommitTrigger from './codecommit-trigger';
export * as codedeployApp from './codedeploy-app';
export * as codedeployDeploymentConfig from './codedeploy-deployment-config';
export * as codedeployDeploymentGroup from './codedeploy-deployment-group';
export * as codeguruprofilerProfilingGroup from './codeguruprofiler-profiling-group';
export * as codegurureviewerRepositoryAssociation from './codegurureviewer-repository-association';
export * as codepipeline from './codepipeline';
export * as codepipelineCustomActionType from './codepipeline-custom-action-type';
export * as codepipelineWebhook from './codepipeline-webhook';
export * as codestarconnectionsConnection from './codestarconnections-connection';
export * as codestarconnectionsHost from './codestarconnections-host';
export * as codestarnotificationsNotificationRule from './codestarnotifications-notification-rule';
export * as cognitoIdentityPool from './cognito-identity-pool';
export * as cognitoIdentityPoolProviderPrincipalTag from './cognito-identity-pool-provider-principal-tag';
export * as cognitoIdentityPoolRolesAttachment from './cognito-identity-pool-roles-attachment';
export * as cognitoIdentityProvider from './cognito-identity-provider';
export * as cognitoManagedUserPoolClient from './cognito-managed-user-pool-client';
export * as cognitoResourceServer from './cognito-resource-server';
export * as cognitoRiskConfiguration from './cognito-risk-configuration';
export * as cognitoUser from './cognito-user';
export * as cognitoUserGroup from './cognito-user-group';
export * as cognitoUserInGroup from './cognito-user-in-group';
export * as cognitoUserPool from './cognito-user-pool';
export * as cognitoUserPoolClient from './cognito-user-pool-client';
export * as cognitoUserPoolDomain from './cognito-user-pool-domain';
export * as cognitoUserPoolUiCustomization from './cognito-user-pool-ui-customization';
export * as comprehendDocumentClassifier from './comprehend-document-classifier';
export * as comprehendEntityRecognizer from './comprehend-entity-recognizer';
export * as configAggregateAuthorization from './config-aggregate-authorization';
export * as configConfigRule from './config-config-rule';
export * as configConfigurationAggregator from './config-configuration-aggregator';
export * as configConfigurationRecorder from './config-configuration-recorder';
export * as configConfigurationRecorderStatus from './config-configuration-recorder-status';
export * as configConformancePack from './config-conformance-pack';
export * as configDeliveryChannel from './config-delivery-channel';
export * as configOrganizationConformancePack from './config-organization-conformance-pack';
export * as configOrganizationCustomPolicyRule from './config-organization-custom-policy-rule';
export * as configOrganizationCustomRule from './config-organization-custom-rule';
export * as configOrganizationManagedRule from './config-organization-managed-rule';
export * as configRemediationConfiguration from './config-remediation-configuration';
export * as configRetentionConfiguration from './config-retention-configuration';
export * as connectBotAssociation from './connect-bot-association';
export * as connectContactFlow from './connect-contact-flow';
export * as connectContactFlowModule from './connect-contact-flow-module';
export * as connectHoursOfOperation from './connect-hours-of-operation';
export * as connectInstance from './connect-instance';
export * as connectInstanceStorageConfig from './connect-instance-storage-config';
export * as connectLambdaFunctionAssociation from './connect-lambda-function-association';
export * as connectPhoneNumber from './connect-phone-number';
export * as connectQueue from './connect-queue';
export * as connectQuickConnect from './connect-quick-connect';
export * as connectRoutingProfile from './connect-routing-profile';
export * as connectSecurityProfile from './connect-security-profile';
export * as connectUser from './connect-user';
export * as connectUserHierarchyGroup from './connect-user-hierarchy-group';
export * as connectUserHierarchyStructure from './connect-user-hierarchy-structure';
export * as connectVocabulary from './connect-vocabulary';
export * as controltowerControl from './controltower-control';
export * as controltowerLandingZone from './controltower-landing-zone';
export * as curReportDefinition from './cur-report-definition';
export * as customerGateway from './customer-gateway';
export * as customerprofilesDomain from './customerprofiles-domain';
export * as customerprofilesProfile from './customerprofiles-profile';
export * as dataexchangeDataSet from './dataexchange-data-set';
export * as dataexchangeRevision from './dataexchange-revision';
export * as datapipelinePipeline from './datapipeline-pipeline';
export * as datapipelinePipelineDefinition from './datapipeline-pipeline-definition';
export * as datasyncAgent from './datasync-agent';
export * as datasyncLocationAzureBlob from './datasync-location-azure-blob';
export * as datasyncLocationEfs from './datasync-location-efs';
export * as datasyncLocationFsxLustreFileSystem from './datasync-location-fsx-lustre-file-system';
export * as datasyncLocationFsxOntapFileSystem from './datasync-location-fsx-ontap-file-system';
export * as datasyncLocationFsxOpenzfsFileSystem from './datasync-location-fsx-openzfs-file-system';
export * as datasyncLocationFsxWindowsFileSystem from './datasync-location-fsx-windows-file-system';
export * as datasyncLocationHdfs from './datasync-location-hdfs';
export * as datasyncLocationNfs from './datasync-location-nfs';
export * as datasyncLocationObjectStorage from './datasync-location-object-storage';
export * as datasyncLocationS3 from './datasync-location-s3';
export * as datasyncLocationSmb from './datasync-location-smb';
export * as datasyncTask from './datasync-task';
export * as daxCluster from './dax-cluster';
export * as daxParameterGroup from './dax-parameter-group';
export * as daxSubnetGroup from './dax-subnet-group';
export * as dbClusterSnapshot from './db-cluster-snapshot';
export * as dbEventSubscription from './db-event-subscription';
export * as dbInstance from './db-instance';
export * as dbInstanceAutomatedBackupsReplication from './db-instance-automated-backups-replication';
export * as dbInstanceRoleAssociation from './db-instance-role-association';
export * as dbOptionGroup from './db-option-group';
export * as dbParameterGroup from './db-parameter-group';
export * as dbProxy from './db-proxy';
export * as dbProxyDefaultTargetGroup from './db-proxy-default-target-group';
export * as dbProxyEndpoint from './db-proxy-endpoint';
export * as dbProxyTarget from './db-proxy-target';
export * as dbSnapshot from './db-snapshot';
export * as dbSnapshotCopy from './db-snapshot-copy';
export * as dbSubnetGroup from './db-subnet-group';
export * as defaultNetworkAcl from './default-network-acl';
export * as defaultRouteTable from './default-route-table';
export * as defaultSecurityGroup from './default-security-group';
export * as defaultSubnet from './default-subnet';
export * as defaultVpc from './default-vpc';
export * as defaultVpcDhcpOptions from './default-vpc-dhcp-options';
export * as detectiveGraph from './detective-graph';
export * as detectiveInvitationAccepter from './detective-invitation-accepter';
export * as detectiveMember from './detective-member';
export * as detectiveOrganizationAdminAccount from './detective-organization-admin-account';
export * as detectiveOrganizationConfiguration from './detective-organization-configuration';
export * as devicefarmDevicePool from './devicefarm-device-pool';
export * as devicefarmInstanceProfile from './devicefarm-instance-profile';
export * as devicefarmNetworkProfile from './devicefarm-network-profile';
export * as devicefarmProject from './devicefarm-project';
export * as devicefarmTestGridProject from './devicefarm-test-grid-project';
export * as devicefarmUpload from './devicefarm-upload';
export * as devopsguruEventSourcesConfig from './devopsguru-event-sources-config';
export * as devopsguruNotificationChannel from './devopsguru-notification-channel';
export * as devopsguruResourceCollection from './devopsguru-resource-collection';
export * as devopsguruServiceIntegration from './devopsguru-service-integration';
export * as directoryServiceConditionalForwarder from './directory-service-conditional-forwarder';
export * as directoryServiceDirectory from './directory-service-directory';
export * as directoryServiceLogSubscription from './directory-service-log-subscription';
export * as directoryServiceRadiusSettings from './directory-service-radius-settings';
export * as directoryServiceRegion from './directory-service-region';
export * as directoryServiceSharedDirectory from './directory-service-shared-directory';
export * as directoryServiceSharedDirectoryAccepter from './directory-service-shared-directory-accepter';
export * as directoryServiceTrust from './directory-service-trust';
export * as dlmLifecyclePolicy from './dlm-lifecycle-policy';
export * as dmsCertificate from './dms-certificate';
export * as dmsEndpoint from './dms-endpoint';
export * as dmsEventSubscription from './dms-event-subscription';
export * as dmsReplicationConfig from './dms-replication-config';
export * as dmsReplicationInstance from './dms-replication-instance';
export * as dmsReplicationSubnetGroup from './dms-replication-subnet-group';
export * as dmsReplicationTask from './dms-replication-task';
export * as dmsS3Endpoint from './dms-s3-endpoint';
export * as docdbCluster from './docdb-cluster';
export * as docdbClusterInstance from './docdb-cluster-instance';
export * as docdbClusterParameterGroup from './docdb-cluster-parameter-group';
export * as docdbClusterSnapshot from './docdb-cluster-snapshot';
export * as docdbEventSubscription from './docdb-event-subscription';
export * as docdbGlobalCluster from './docdb-global-cluster';
export * as docdbSubnetGroup from './docdb-subnet-group';
export * as docdbelasticCluster from './docdbelastic-cluster';
export * as dxBgpPeer from './dx-bgp-peer';
export * as dxConnection from './dx-connection';
export * as dxConnectionAssociation from './dx-connection-association';
export * as dxConnectionConfirmation from './dx-connection-confirmation';
export * as dxGateway from './dx-gateway';
export * as dxGatewayAssociation from './dx-gateway-association';
export * as dxGatewayAssociationProposal from './dx-gateway-association-proposal';
export * as dxHostedConnection from './dx-hosted-connection';
export * as dxHostedPrivateVirtualInterface from './dx-hosted-private-virtual-interface';
export * as dxHostedPrivateVirtualInterfaceAccepter from './dx-hosted-private-virtual-interface-accepter';
export * as dxHostedPublicVirtualInterface from './dx-hosted-public-virtual-interface';
export * as dxHostedPublicVirtualInterfaceAccepter from './dx-hosted-public-virtual-interface-accepter';
export * as dxHostedTransitVirtualInterface from './dx-hosted-transit-virtual-interface';
export * as dxHostedTransitVirtualInterfaceAccepter from './dx-hosted-transit-virtual-interface-accepter';
export * as dxLag from './dx-lag';
export * as dxMacsecKeyAssociation from './dx-macsec-key-association';
export * as dxPrivateVirtualInterface from './dx-private-virtual-interface';
export * as dxPublicVirtualInterface from './dx-public-virtual-interface';
export * as dxTransitVirtualInterface from './dx-transit-virtual-interface';
export * as dynamodbContributorInsights from './dynamodb-contributor-insights';
export * as dynamodbGlobalTable from './dynamodb-global-table';
export * as dynamodbKinesisStreamingDestination from './dynamodb-kinesis-streaming-destination';
export * as dynamodbResourcePolicy from './dynamodb-resource-policy';
export * as dynamodbTable from './dynamodb-table';
export * as dynamodbTableExport from './dynamodb-table-export';
export * as dynamodbTableItem from './dynamodb-table-item';
export * as dynamodbTableReplica from './dynamodb-table-replica';
export * as dynamodbTag from './dynamodb-tag';
export * as ebsDefaultKmsKey from './ebs-default-kms-key';
export * as ebsEncryptionByDefault from './ebs-encryption-by-default';
export * as ebsFastSnapshotRestore from './ebs-fast-snapshot-restore';
export * as ebsSnapshot from './ebs-snapshot';
export * as ebsSnapshotCopy from './ebs-snapshot-copy';
export * as ebsSnapshotImport from './ebs-snapshot-import';
export * as ebsVolume from './ebs-volume';
export * as ec2AvailabilityZoneGroup from './ec2-availability-zone-group';
export * as ec2CapacityReservation from './ec2-capacity-reservation';
export * as ec2CarrierGateway from './ec2-carrier-gateway';
export * as ec2ClientVpnAuthorizationRule from './ec2-client-vpn-authorization-rule';
export * as ec2ClientVpnEndpoint from './ec2-client-vpn-endpoint';
export * as ec2ClientVpnNetworkAssociation from './ec2-client-vpn-network-association';
export * as ec2ClientVpnRoute from './ec2-client-vpn-route';
export * as ec2Fleet from './ec2-fleet';
export * as ec2Host from './ec2-host';
export * as ec2ImageBlockPublicAccess from './ec2-image-block-public-access';
export * as ec2InstanceConnectEndpoint from './ec2-instance-connect-endpoint';
export * as ec2InstanceMetadataDefaults from './ec2-instance-metadata-defaults';
export * as ec2InstanceState from './ec2-instance-state';
export * as ec2LocalGatewayRoute from './ec2-local-gateway-route';
export * as ec2LocalGatewayRouteTableVpcAssociation from './ec2-local-gateway-route-table-vpc-association';
export * as ec2ManagedPrefixList from './ec2-managed-prefix-list';
export * as ec2ManagedPrefixListEntry from './ec2-managed-prefix-list-entry';
export * as ec2NetworkInsightsAnalysis from './ec2-network-insights-analysis';
export * as ec2NetworkInsightsPath from './ec2-network-insights-path';
export * as ec2SerialConsoleAccess from './ec2-serial-console-access';
export * as ec2SubnetCidrReservation from './ec2-subnet-cidr-reservation';
export * as ec2Tag from './ec2-tag';
export * as ec2TrafficMirrorFilter from './ec2-traffic-mirror-filter';
export * as ec2TrafficMirrorFilterRule from './ec2-traffic-mirror-filter-rule';
export * as ec2TrafficMirrorSession from './ec2-traffic-mirror-session';
export * as ec2TrafficMirrorTarget from './ec2-traffic-mirror-target';
export * as ec2TransitGateway from './ec2-transit-gateway';
export * as ec2TransitGatewayConnect from './ec2-transit-gateway-connect';
export * as ec2TransitGatewayConnectPeer from './ec2-transit-gateway-connect-peer';
export * as ec2TransitGatewayMulticastDomain from './ec2-transit-gateway-multicast-domain';
export * as ec2TransitGatewayMulticastDomainAssociation from './ec2-transit-gateway-multicast-domain-association';
export * as ec2TransitGatewayMulticastGroupMember from './ec2-transit-gateway-multicast-group-member';
export * as ec2TransitGatewayMulticastGroupSource from './ec2-transit-gateway-multicast-group-source';
export * as ec2TransitGatewayPeeringAttachment from './ec2-transit-gateway-peering-attachment';
export * as ec2TransitGatewayPeeringAttachmentAccepter from './ec2-transit-gateway-peering-attachment-accepter';
export * as ec2TransitGatewayPolicyTable from './ec2-transit-gateway-policy-table';
export * as ec2TransitGatewayPolicyTableAssociation from './ec2-transit-gateway-policy-table-association';
export * as ec2TransitGatewayPrefixListReference from './ec2-transit-gateway-prefix-list-reference';
export * as ec2TransitGatewayRoute from './ec2-transit-gateway-route';
export * as ec2TransitGatewayRouteTable from './ec2-transit-gateway-route-table';
export * as ec2TransitGatewayRouteTableAssociation from './ec2-transit-gateway-route-table-association';
export * as ec2TransitGatewayRouteTablePropagation from './ec2-transit-gateway-route-table-propagation';
export * as ec2TransitGatewayVpcAttachment from './ec2-transit-gateway-vpc-attachment';
export * as ec2TransitGatewayVpcAttachmentAccepter from './ec2-transit-gateway-vpc-attachment-accepter';
export * as ecrLifecyclePolicy from './ecr-lifecycle-policy';
export * as ecrPullThroughCacheRule from './ecr-pull-through-cache-rule';
export * as ecrRegistryPolicy from './ecr-registry-policy';
export * as ecrRegistryScanningConfiguration from './ecr-registry-scanning-configuration';
export * as ecrReplicationConfiguration from './ecr-replication-configuration';
export * as ecrRepository from './ecr-repository';
export * as ecrRepositoryPolicy from './ecr-repository-policy';
export * as ecrpublicRepository from './ecrpublic-repository';
export * as ecrpublicRepositoryPolicy from './ecrpublic-repository-policy';
export * as ecsAccountSettingDefault from './ecs-account-setting-default';
export * as ecsCapacityProvider from './ecs-capacity-provider';
export * as ecsCluster from './ecs-cluster';
export * as ecsClusterCapacityProviders from './ecs-cluster-capacity-providers';
export * as ecsService from './ecs-service';
export * as ecsTag from './ecs-tag';
export * as ecsTaskDefinition from './ecs-task-definition';
export * as ecsTaskSet from './ecs-task-set';
export * as efsAccessPoint from './efs-access-point';
export * as efsBackupPolicy from './efs-backup-policy';
export * as efsFileSystem from './efs-file-system';
export * as efsFileSystemPolicy from './efs-file-system-policy';
export * as efsMountTarget from './efs-mount-target';
export * as efsReplicationConfiguration from './efs-replication-configuration';
export * as egressOnlyInternetGateway from './egress-only-internet-gateway';
export * as eip from './eip';
export * as eipAssociation from './eip-association';
export * as eipDomainName from './eip-domain-name';
export * as eksAccessEntry from './eks-access-entry';
export * as eksAccessPolicyAssociation from './eks-access-policy-association';
export * as eksAddon from './eks-addon';
export * as eksCluster from './eks-cluster';
export * as eksFargateProfile from './eks-fargate-profile';
export * as eksIdentityProviderConfig from './eks-identity-provider-config';
export * as eksNodeGroup from './eks-node-group';
export * as eksPodIdentityAssociation from './eks-pod-identity-association';
export * as elasticBeanstalkApplication from './elastic-beanstalk-application';
export * as elasticBeanstalkApplicationVersion from './elastic-beanstalk-application-version';
export * as elasticBeanstalkConfigurationTemplate from './elastic-beanstalk-configuration-template';
export * as elasticBeanstalkEnvironment from './elastic-beanstalk-environment';
export * as elasticacheCluster from './elasticache-cluster';
export * as elasticacheGlobalReplicationGroup from './elasticache-global-replication-group';
export * as elasticacheParameterGroup from './elasticache-parameter-group';
export * as elasticacheReplicationGroup from './elasticache-replication-group';
export * as elasticacheServerlessCache from './elasticache-serverless-cache';
export * as elasticacheSubnetGroup from './elasticache-subnet-group';
export * as elasticacheUser from './elasticache-user';
export * as elasticacheUserGroup from './elasticache-user-group';
export * as elasticacheUserGroupAssociation from './elasticache-user-group-association';
export * as elasticsearchDomain from './elasticsearch-domain';
export * as elasticsearchDomainPolicy from './elasticsearch-domain-policy';
export * as elasticsearchDomainSamlOptions from './elasticsearch-domain-saml-options';
export * as elasticsearchVpcEndpoint from './elasticsearch-vpc-endpoint';
export * as elastictranscoderPipeline from './elastictranscoder-pipeline';
export * as elastictranscoderPreset from './elastictranscoder-preset';
export * as elb from './elb';
export * as elbAttachment from './elb-attachment';
export * as emrBlockPublicAccessConfiguration from './emr-block-public-access-configuration';
export * as emrCluster from './emr-cluster';
export * as emrInstanceFleet from './emr-instance-fleet';
export * as emrInstanceGroup from './emr-instance-group';
export * as emrManagedScalingPolicy from './emr-managed-scaling-policy';
export * as emrSecurityConfiguration from './emr-security-configuration';
export * as emrStudio from './emr-studio';
export * as emrStudioSessionMapping from './emr-studio-session-mapping';
export * as emrcontainersJobTemplate from './emrcontainers-job-template';
export * as emrcontainersVirtualCluster from './emrcontainers-virtual-cluster';
export * as emrserverlessApplication from './emrserverless-application';
export * as evidentlyFeature from './evidently-feature';
export * as evidentlyLaunch from './evidently-launch';
export * as evidentlyProject from './evidently-project';
export * as evidentlySegment from './evidently-segment';
export * as finspaceKxCluster from './finspace-kx-cluster';
export * as finspaceKxDatabase from './finspace-kx-database';
export * as finspaceKxDataview from './finspace-kx-dataview';
export * as finspaceKxEnvironment from './finspace-kx-environment';
export * as finspaceKxScalingGroup from './finspace-kx-scaling-group';
export * as finspaceKxUser from './finspace-kx-user';
export * as finspaceKxVolume from './finspace-kx-volume';
export * as fisExperimentTemplate from './fis-experiment-template';
export * as flowLog from './flow-log';
export * as fmsAdminAccount from './fms-admin-account';
export * as fmsPolicy from './fms-policy';
export * as fsxBackup from './fsx-backup';
export * as fsxDataRepositoryAssociation from './fsx-data-repository-association';
export * as fsxFileCache from './fsx-file-cache';
export * as fsxLustreFileSystem from './fsx-lustre-file-system';
export * as fsxOntapFileSystem from './fsx-ontap-file-system';
export * as fsxOntapStorageVirtualMachine from './fsx-ontap-storage-virtual-machine';
export * as fsxOntapVolume from './fsx-ontap-volume';
export * as fsxOpenzfsFileSystem from './fsx-openzfs-file-system';
export * as fsxOpenzfsSnapshot from './fsx-openzfs-snapshot';
export * as fsxOpenzfsVolume from './fsx-openzfs-volume';
export * as fsxWindowsFileSystem from './fsx-windows-file-system';
export * as gameliftAlias from './gamelift-alias';
export * as gameliftBuild from './gamelift-build';
export * as gameliftFleet from './gamelift-fleet';
export * as gameliftGameServerGroup from './gamelift-game-server-group';
export * as gameliftGameSessionQueue from './gamelift-game-session-queue';
export * as gameliftScript from './gamelift-script';
export * as glacierVault from './glacier-vault';
export * as glacierVaultLock from './glacier-vault-lock';
export * as globalacceleratorAccelerator from './globalaccelerator-accelerator';
export * as globalacceleratorCrossAccountAttachment from './globalaccelerator-cross-account-attachment';
export * as globalacceleratorCustomRoutingAccelerator from './globalaccelerator-custom-routing-accelerator';
export * as globalacceleratorCustomRoutingEndpointGroup from './globalaccelerator-custom-routing-endpoint-group';
export * as globalacceleratorCustomRoutingListener from './globalaccelerator-custom-routing-listener';
export * as globalacceleratorEndpointGroup from './globalaccelerator-endpoint-group';
export * as globalacceleratorListener from './globalaccelerator-listener';
export * as glueCatalogDatabase from './glue-catalog-database';
export * as glueCatalogTable from './glue-catalog-table';
export * as glueClassifier from './glue-classifier';
export * as glueConnection from './glue-connection';
export * as glueCrawler from './glue-crawler';
export * as glueDataCatalogEncryptionSettings from './glue-data-catalog-encryption-settings';
export * as glueDataQualityRuleset from './glue-data-quality-ruleset';
export * as glueDevEndpoint from './glue-dev-endpoint';
export * as glueJob from './glue-job';
export * as glueMlTransform from './glue-ml-transform';
export * as gluePartition from './glue-partition';
export * as gluePartitionIndex from './glue-partition-index';
export * as glueRegistry from './glue-registry';
export * as glueResourcePolicy from './glue-resource-policy';
export * as glueSchema from './glue-schema';
export * as glueSecurityConfiguration from './glue-security-configuration';
export * as glueTrigger from './glue-trigger';
export * as glueUserDefinedFunction from './glue-user-defined-function';
export * as glueWorkflow from './glue-workflow';
export * as grafanaLicenseAssociation from './grafana-license-association';
export * as grafanaRoleAssociation from './grafana-role-association';
export * as grafanaWorkspace from './grafana-workspace';
export * as grafanaWorkspaceApiKey from './grafana-workspace-api-key';
export * as grafanaWorkspaceSamlConfiguration from './grafana-workspace-saml-configuration';
export * as guarddutyDetector from './guardduty-detector';
export * as guarddutyDetectorFeature from './guardduty-detector-feature';
export * as guarddutyFilter from './guardduty-filter';
export * as guarddutyInviteAccepter from './guardduty-invite-accepter';
export * as guarddutyIpset from './guardduty-ipset';
export * as guarddutyMember from './guardduty-member';
export * as guarddutyOrganizationAdminAccount from './guardduty-organization-admin-account';
export * as guarddutyOrganizationConfiguration from './guardduty-organization-configuration';
export * as guarddutyOrganizationConfigurationFeature from './guardduty-organization-configuration-feature';
export * as guarddutyPublishingDestination from './guardduty-publishing-destination';
export * as guarddutyThreatintelset from './guardduty-threatintelset';
export * as iamAccessKey from './iam-access-key';
export * as iamAccountAlias from './iam-account-alias';
export * as iamAccountPasswordPolicy from './iam-account-password-policy';
export * as iamGroup from './iam-group';
export * as iamGroupMembership from './iam-group-membership';
export * as iamGroupPolicy from './iam-group-policy';
export * as iamGroupPolicyAttachment from './iam-group-policy-attachment';
export * as iamInstanceProfile from './iam-instance-profile';
export * as iamOpenidConnectProvider from './iam-openid-connect-provider';
export * as iamPolicy from './iam-policy';
export * as iamPolicyAttachment from './iam-policy-attachment';
export * as iamRole from './iam-role';
export * as iamRolePolicy from './iam-role-policy';
export * as iamRolePolicyAttachment from './iam-role-policy-attachment';
export * as iamSamlProvider from './iam-saml-provider';
export * as iamSecurityTokenServicePreferences from './iam-security-token-service-preferences';
export * as iamServerCertificate from './iam-server-certificate';
export * as iamServiceLinkedRole from './iam-service-linked-role';
export * as iamServiceSpecificCredential from './iam-service-specific-credential';
export * as iamSigningCertificate from './iam-signing-certificate';
export * as iamUser from './iam-user';
export * as iamUserGroupMembership from './iam-user-group-membership';
export * as iamUserLoginProfile from './iam-user-login-profile';
export * as iamUserPolicy from './iam-user-policy';
export * as iamUserPolicyAttachment from './iam-user-policy-attachment';
export * as iamUserSshKey from './iam-user-ssh-key';
export * as iamVirtualMfaDevice from './iam-virtual-mfa-device';
export * as identitystoreGroup from './identitystore-group';
export * as identitystoreGroupMembership from './identitystore-group-membership';
export * as identitystoreUser from './identitystore-user';
export * as imagebuilderComponent from './imagebuilder-component';
export * as imagebuilderContainerRecipe from './imagebuilder-container-recipe';
export * as imagebuilderDistributionConfiguration from './imagebuilder-distribution-configuration';
export * as imagebuilderImage from './imagebuilder-image';
export * as imagebuilderImagePipeline from './imagebuilder-image-pipeline';
export * as imagebuilderImageRecipe from './imagebuilder-image-recipe';
export * as imagebuilderInfrastructureConfiguration from './imagebuilder-infrastructure-configuration';
export * as imagebuilderWorkflow from './imagebuilder-workflow';
export * as inspector2DelegatedAdminAccount from './inspector2-delegated-admin-account';
export * as inspector2Enabler from './inspector2-enabler';
export * as inspector2MemberAssociation from './inspector2-member-association';
export * as inspector2OrganizationConfiguration from './inspector2-organization-configuration';
export * as inspectorAssessmentTarget from './inspector-assessment-target';
export * as inspectorAssessmentTemplate from './inspector-assessment-template';
export * as inspectorResourceGroup from './inspector-resource-group';
export * as instance from './instance';
export * as internetGateway from './internet-gateway';
export * as internetGatewayAttachment from './internet-gateway-attachment';
export * as internetmonitorMonitor from './internetmonitor-monitor';
export * as iotAuthorizer from './iot-authorizer';
export * as iotBillingGroup from './iot-billing-group';
export * as iotCaCertificate from './iot-ca-certificate';
export * as iotCertificate from './iot-certificate';
export * as iotDomainConfiguration from './iot-domain-configuration';
export * as iotEventConfigurations from './iot-event-configurations';
export * as iotIndexingConfiguration from './iot-indexing-configuration';
export * as iotLoggingOptions from './iot-logging-options';
export * as iotPolicy from './iot-policy';
export * as iotPolicyAttachment from './iot-policy-attachment';
export * as iotProvisioningTemplate from './iot-provisioning-template';
export * as iotRoleAlias from './iot-role-alias';
export * as iotThing from './iot-thing';
export * as iotThingGroup from './iot-thing-group';
export * as iotThingGroupMembership from './iot-thing-group-membership';
export * as iotThingPrincipalAttachment from './iot-thing-principal-attachment';
export * as iotThingType from './iot-thing-type';
export * as iotTopicRule from './iot-topic-rule';
export * as iotTopicRuleDestination from './iot-topic-rule-destination';
export * as ivsChannel from './ivs-channel';
export * as ivsPlaybackKeyPair from './ivs-playback-key-pair';
export * as ivsRecordingConfiguration from './ivs-recording-configuration';
export * as ivschatLoggingConfiguration from './ivschat-logging-configuration';
export * as ivschatRoom from './ivschat-room';
export * as kendraDataSource from './kendra-data-source';
export * as kendraExperience from './kendra-experience';
export * as kendraFaq from './kendra-faq';
export * as kendraIndex from './kendra-index';
export * as kendraQuerySuggestionsBlockList from './kendra-query-suggestions-block-list';
export * as kendraThesaurus from './kendra-thesaurus';
export * as keyPair from './key-pair';
export * as keyspacesKeyspace from './keyspaces-keyspace';
export * as keyspacesTable from './keyspaces-table';
export * as kinesisAnalyticsApplication from './kinesis-analytics-application';
export * as kinesisFirehoseDeliveryStream from './kinesis-firehose-delivery-stream';
export * as kinesisResourcePolicy from './kinesis-resource-policy';
export * as kinesisStream from './kinesis-stream';
export * as kinesisStreamConsumer from './kinesis-stream-consumer';
export * as kinesisVideoStream from './kinesis-video-stream';
export * as kinesisanalyticsv2Application from './kinesisanalyticsv2-application';
export * as kinesisanalyticsv2ApplicationSnapshot from './kinesisanalyticsv2-application-snapshot';
export * as kmsAlias from './kms-alias';
export * as kmsCiphertext from './kms-ciphertext';
export * as kmsCustomKeyStore from './kms-custom-key-store';
export * as kmsExternalKey from './kms-external-key';
export * as kmsGrant from './kms-grant';
export * as kmsKey from './kms-key';
export * as kmsKeyPolicy from './kms-key-policy';
export * as kmsReplicaExternalKey from './kms-replica-external-key';
export * as kmsReplicaKey from './kms-replica-key';
export * as lakeformationDataCellsFilter from './lakeformation-data-cells-filter';
export * as lakeformationDataLakeSettings from './lakeformation-data-lake-settings';
export * as lakeformationLfTag from './lakeformation-lf-tag';
export * as lakeformationPermissions from './lakeformation-permissions';
export * as lakeformationResource from './lakeformation-resource';
export * as lakeformationResourceLfTag from './lakeformation-resource-lf-tag';
export * as lakeformationResourceLfTags from './lakeformation-resource-lf-tags';
export * as lambdaAlias from './lambda-alias';
export * as lambdaCodeSigningConfig from './lambda-code-signing-config';
export * as lambdaEventSourceMapping from './lambda-event-source-mapping';
export * as lambdaFunction from './lambda-function';
export * as lambdaFunctionEventInvokeConfig from './lambda-function-event-invoke-config';
export * as lambdaFunctionUrl from './lambda-function-url';
export * as lambdaInvocation from './lambda-invocation';
export * as lambdaLayerVersion from './lambda-layer-version';
export * as lambdaLayerVersionPermission from './lambda-layer-version-permission';
export * as lambdaPermission from './lambda-permission';
export * as lambdaProvisionedConcurrencyConfig from './lambda-provisioned-concurrency-config';
export * as launchConfiguration from './launch-configuration';
export * as launchTemplate from './launch-template';
export * as lb from './lb';
export * as lbCookieStickinessPolicy from './lb-cookie-stickiness-policy';
export * as lbListener from './lb-listener';
export * as lbListenerCertificate from './lb-listener-certificate';
export * as lbListenerRule from './lb-listener-rule';
export * as lbSslNegotiationPolicy from './lb-ssl-negotiation-policy';
export * as lbTargetGroup from './lb-target-group';
export * as lbTargetGroupAttachment from './lb-target-group-attachment';
export * as lbTrustStore from './lb-trust-store';
export * as lbTrustStoreRevocation from './lb-trust-store-revocation';
export * as lexBot from './lex-bot';
export * as lexBotAlias from './lex-bot-alias';
export * as lexIntent from './lex-intent';
export * as lexSlotType from './lex-slot-type';
export * as lexv2ModelsBot from './lexv2models-bot';
export * as lexv2ModelsBotLocale from './lexv2models-bot-locale';
export * as lexv2ModelsBotVersion from './lexv2models-bot-version';
export * as lexv2ModelsIntent from './lexv2models-intent';
export * as lexv2ModelsSlot from './lexv2models-slot';
export * as lexv2ModelsSlotType from './lexv2models-slot-type';
export * as licensemanagerAssociation from './licensemanager-association';
export * as licensemanagerGrant from './licensemanager-grant';
export * as licensemanagerGrantAccepter from './licensemanager-grant-accepter';
export * as licensemanagerLicenseConfiguration from './licensemanager-license-configuration';
export * as lightsailBucket from './lightsail-bucket';
export * as lightsailBucketAccessKey from './lightsail-bucket-access-key';
export * as lightsailBucketResourceAccess from './lightsail-bucket-resource-access';
export * as lightsailCertificate from './lightsail-certificate';
export * as lightsailContainerService from './lightsail-container-service';
export * as lightsailContainerServiceDeploymentVersion from './lightsail-container-service-deployment-version';
export * as lightsailDatabase from './lightsail-database';
export * as lightsailDisk from './lightsail-disk';
export * as lightsailDiskAttachment from './lightsail-disk-attachment';
export * as lightsailDistribution from './lightsail-distribution';
export * as lightsailDomain from './lightsail-domain';
export * as lightsailDomainEntry from './lightsail-domain-entry';
export * as lightsailInstance from './lightsail-instance';
export * as lightsailInstancePublicPorts from './lightsail-instance-public-ports';
export * as lightsailKeyPair from './lightsail-key-pair';
export * as lightsailLb from './lightsail-lb';
export * as lightsailLbAttachment from './lightsail-lb-attachment';
export * as lightsailLbCertificate from './lightsail-lb-certificate';
export * as lightsailLbCertificateAttachment from './lightsail-lb-certificate-attachment';
export * as lightsailLbHttpsRedirectionPolicy from './lightsail-lb-https-redirection-policy';
export * as lightsailLbStickinessPolicy from './lightsail-lb-stickiness-policy';
export * as lightsailStaticIp from './lightsail-static-ip';
export * as lightsailStaticIpAttachment from './lightsail-static-ip-attachment';
export * as loadBalancerBackendServerPolicy from './load-balancer-backend-server-policy';
export * as loadBalancerListenerPolicy from './load-balancer-listener-policy';
export * as loadBalancerPolicy from './load-balancer-policy';
export * as locationGeofenceCollection from './location-geofence-collection';
export * as locationMap from './location-map';
export * as locationPlaceIndex from './location-place-index';
export * as locationRouteCalculator from './location-route-calculator';
export * as locationTracker from './location-tracker';
export * as locationTrackerAssociation from './location-tracker-association';
export * as m2Application from './m2-application';
export * as m2Deployment from './m2-deployment';
export * as m2Environment from './m2-environment';
export * as macie2Account from './macie2-account';
export * as macie2ClassificationExportConfiguration from './macie2-classification-export-configuration';
export * as macie2ClassificationJob from './macie2-classification-job';
export * as macie2CustomDataIdentifier from './macie2-custom-data-identifier';
export * as macie2FindingsFilter from './macie2-findings-filter';
export * as macie2InvitationAccepter from './macie2-invitation-accepter';
export * as macie2Member from './macie2-member';
export * as macie2OrganizationAdminAccount from './macie2-organization-admin-account';
export * as mainRouteTableAssociation from './main-route-table-association';
export * as mediaConvertQueue from './media-convert-queue';
export * as mediaPackageChannel from './media-package-channel';
export * as mediaStoreContainer from './media-store-container';
export * as mediaStoreContainerPolicy from './media-store-container-policy';
export * as medialiveChannel from './medialive-channel';
export * as medialiveInput from './medialive-input';
export * as medialiveInputSecurityGroup from './medialive-input-security-group';
export * as medialiveMultiplex from './medialive-multiplex';
export * as medialiveMultiplexProgram from './medialive-multiplex-program';
export * as memorydbAcl from './memorydb-acl';
export * as memorydbCluster from './memorydb-cluster';
export * as memorydbParameterGroup from './memorydb-parameter-group';
export * as memorydbSnapshot from './memorydb-snapshot';
export * as memorydbSubnetGroup from './memorydb-subnet-group';
export * as memorydbUser from './memorydb-user';
export * as mqBroker from './mq-broker';
export * as mqConfiguration from './mq-configuration';
export * as mskCluster from './msk-cluster';
export * as mskClusterPolicy from './msk-cluster-policy';
export * as mskConfiguration from './msk-configuration';
export * as mskReplicator from './msk-replicator';
export * as mskScramSecretAssociation from './msk-scram-secret-association';
export * as mskServerlessCluster from './msk-serverless-cluster';
export * as mskVpcConnection from './msk-vpc-connection';
export * as mskconnectConnector from './mskconnect-connector';
export * as mskconnectCustomPlugin from './mskconnect-custom-plugin';
export * as mskconnectWorkerConfiguration from './mskconnect-worker-configuration';
export * as mwaaEnvironment from './mwaa-environment';
export * as natGateway from './nat-gateway';
export * as neptuneCluster from './neptune-cluster';
export * as neptuneClusterEndpoint from './neptune-cluster-endpoint';
export * as neptuneClusterInstance from './neptune-cluster-instance';
export * as neptuneClusterParameterGroup from './neptune-cluster-parameter-group';
export * as neptuneClusterSnapshot from './neptune-cluster-snapshot';
export * as neptuneEventSubscription from './neptune-event-subscription';
export * as neptuneGlobalCluster from './neptune-global-cluster';
export * as neptuneParameterGroup from './neptune-parameter-group';
export * as neptuneSubnetGroup from './neptune-subnet-group';
export * as networkAcl from './network-acl';
export * as networkAclAssociation from './network-acl-association';
export * as networkAclRule from './network-acl-rule';
export * as networkInterface from './network-interface';
export * as networkInterfaceAttachment from './network-interface-attachment';
export * as networkInterfaceSgAttachment from './network-interface-sg-attachment';
export * as networkfirewallFirewall from './networkfirewall-firewall';
export * as networkfirewallFirewallPolicy from './networkfirewall-firewall-policy';
export * as networkfirewallLoggingConfiguration from './networkfirewall-logging-configuration';
export * as networkfirewallResourcePolicy from './networkfirewall-resource-policy';
export * as networkfirewallRuleGroup from './networkfirewall-rule-group';
export * as networkmanagerAttachmentAccepter from './networkmanager-attachment-accepter';
export * as networkmanagerConnectAttachment from './networkmanager-connect-attachment';
export * as networkmanagerConnectPeer from './networkmanager-connect-peer';
export * as networkmanagerConnection from './networkmanager-connection';
export * as networkmanagerCoreNetwork from './networkmanager-core-network';
export * as networkmanagerCoreNetworkPolicyAttachment from './networkmanager-core-network-policy-attachment';
export * as networkmanagerCustomerGatewayAssociation from './networkmanager-customer-gateway-association';
export * as networkmanagerDevice from './networkmanager-device';
export * as networkmanagerGlobalNetwork from './networkmanager-global-network';
export * as networkmanagerLink from './networkmanager-link';
export * as networkmanagerLinkAssociation from './networkmanager-link-association';
export * as networkmanagerSite from './networkmanager-site';
export * as networkmanagerSiteToSiteVpnAttachment from './networkmanager-site-to-site-vpn-attachment';
export * as networkmanagerTransitGatewayConnectPeerAssociation from './networkmanager-transit-gateway-connect-peer-association';
export * as networkmanagerTransitGatewayPeering from './networkmanager-transit-gateway-peering';
export * as networkmanagerTransitGatewayRegistration from './networkmanager-transit-gateway-registration';
export * as networkmanagerTransitGatewayRouteTableAttachment from './networkmanager-transit-gateway-route-table-attachment';
export * as networkmanagerVpcAttachment from './networkmanager-vpc-attachment';
export * as oamLink from './oam-link';
export * as oamSink from './oam-sink';
export * as oamSinkPolicy from './oam-sink-policy';
export * as opensearchDomain from './opensearch-domain';
export * as opensearchDomainPolicy from './opensearch-domain-policy';
export * as opensearchDomainSamlOptions from './opensearch-domain-saml-options';
export * as opensearchInboundConnectionAccepter from './opensearch-inbound-connection-accepter';
export * as opensearchOutboundConnection from './opensearch-outbound-connection';
export * as opensearchPackage from './opensearch-package';
export * as opensearchPackageAssociation from './opensearch-package-association';
export * as opensearchVpcEndpoint from './opensearch-vpc-endpoint';
export * as opensearchserverlessAccessPolicy from './opensearchserverless-access-policy';
export * as opensearchserverlessCollection from './opensearchserverless-collection';
export * as opensearchserverlessLifecyclePolicy from './opensearchserverless-lifecycle-policy';
export * as opensearchserverlessSecurityConfig from './opensearchserverless-security-config';
export * as opensearchserverlessSecurityPolicy from './opensearchserverless-security-policy';
export * as opensearchserverlessVpcEndpoint from './opensearchserverless-vpc-endpoint';
export * as opsworksApplication from './opsworks-application';
export * as opsworksCustomLayer from './opsworks-custom-layer';
export * as opsworksEcsClusterLayer from './opsworks-ecs-cluster-layer';
export * as opsworksGangliaLayer from './opsworks-ganglia-layer';
export * as opsworksHaproxyLayer from './opsworks-haproxy-layer';
export * as opsworksInstance from './opsworks-instance';
export * as opsworksJavaAppLayer from './opsworks-java-app-layer';
export * as opsworksMemcachedLayer from './opsworks-memcached-layer';
export * as opsworksMysqlLayer from './opsworks-mysql-layer';
export * as opsworksNodejsAppLayer from './opsworks-nodejs-app-layer';
export * as opsworksPermission from './opsworks-permission';
export * as opsworksPhpAppLayer from './opsworks-php-app-layer';
export * as opsworksRailsAppLayer from './opsworks-rails-app-layer';
export * as opsworksRdsDbInstance from './opsworks-rds-db-instance';
export * as opsworksStack from './opsworks-stack';
export * as opsworksStaticWebLayer from './opsworks-static-web-layer';
export * as opsworksUserProfile from './opsworks-user-profile';
export * as organizationsAccount from './organizations-account';
export * as organizationsDelegatedAdministrator from './organizations-delegated-administrator';
export * as organizationsOrganization from './organizations-organization';
export * as organizationsOrganizationalUnit from './organizations-organizational-unit';
export * as organizationsPolicy from './organizations-policy';
export * as organizationsPolicyAttachment from './organizations-policy-attachment';
export * as organizationsResourcePolicy from './organizations-resource-policy';
export * as osisPipeline from './osis-pipeline';
export * as pinpointAdmChannel from './pinpoint-adm-channel';
export * as pinpointApnsChannel from './pinpoint-apns-channel';
export * as pinpointApnsSandboxChannel from './pinpoint-apns-sandbox-channel';
export * as pinpointApnsVoipChannel from './pinpoint-apns-voip-channel';
export * as pinpointApnsVoipSandboxChannel from './pinpoint-apns-voip-sandbox-channel';
export * as pinpointApp from './pinpoint-app';
export * as pinpointBaiduChannel from './pinpoint-baidu-channel';
export * as pinpointEmailChannel from './pinpoint-email-channel';
export * as pinpointEventStream from './pinpoint-event-stream';
export * as pinpointGcmChannel from './pinpoint-gcm-channel';
export * as pinpointSmsChannel from './pinpoint-sms-channel';
export * as pipesPipe from './pipes-pipe';
export * as placementGroup from './placement-group';
export * as prometheusAlertManagerDefinition from './prometheus-alert-manager-definition';
export * as prometheusRuleGroupNamespace from './prometheus-rule-group-namespace';
export * as prometheusScraper from './prometheus-scraper';
export * as prometheusWorkspace from './prometheus-workspace';
export * as proxyProtocolPolicy from './proxy-protocol-policy';
export * as qldbLedger from './qldb-ledger';
export * as qldbStream from './qldb-stream';
export * as quicksightAccountSubscription from './quicksight-account-subscription';
export * as quicksightAnalysis from './quicksight-analysis';
export * as quicksightDashboard from './quicksight-dashboard';
export * as quicksightDataSet from './quicksight-data-set';
export * as quicksightDataSource from './quicksight-data-source';
export * as quicksightFolder from './quicksight-folder';
export * as quicksightFolderMembership from './quicksight-folder-membership';
export * as quicksightGroup from './quicksight-group';
export * as quicksightGroupMembership from './quicksight-group-membership';
export * as quicksightIamPolicyAssignment from './quicksight-iam-policy-assignment';
export * as quicksightIngestion from './quicksight-ingestion';
export * as quicksightNamespace from './quicksight-namespace';
export * as quicksightRefreshSchedule from './quicksight-refresh-schedule';
export * as quicksightTemplate from './quicksight-template';
export * as quicksightTemplateAlias from './quicksight-template-alias';
export * as quicksightTheme from './quicksight-theme';
export * as quicksightUser from './quicksight-user';
export * as quicksightVpcConnection from './quicksight-vpc-connection';
export * as ramPrincipalAssociation from './ram-principal-association';
export * as ramResourceAssociation from './ram-resource-association';
export * as ramResourceShare from './ram-resource-share';
export * as ramResourceShareAccepter from './ram-resource-share-accepter';
export * as ramSharingWithOrganization from './ram-sharing-with-organization';
export * as rbinRule from './rbin-rule';
export * as rdsCluster from './rds-cluster';
export * as rdsClusterActivityStream from './rds-cluster-activity-stream';
export * as rdsClusterEndpoint from './rds-cluster-endpoint';
export * as rdsClusterInstance from './rds-cluster-instance';
export * as rdsClusterParameterGroup from './rds-cluster-parameter-group';
export * as rdsClusterRoleAssociation from './rds-cluster-role-association';
export * as rdsCustomDbEngineVersion from './rds-custom-db-engine-version';
export * as rdsExportTask from './rds-export-task';
export * as rdsGlobalCluster from './rds-global-cluster';
export * as rdsReservedInstance from './rds-reserved-instance';
export * as redshiftAuthenticationProfile from './redshift-authentication-profile';
export * as redshiftCluster from './redshift-cluster';
export * as redshiftClusterIamRoles from './redshift-cluster-iam-roles';
export * as redshiftClusterSnapshot from './redshift-cluster-snapshot';
export * as redshiftDataShareAuthorization from './redshift-data-share-authorization';
export * as redshiftDataShareConsumerAssociation from './redshift-data-share-consumer-association';
export * as redshiftEndpointAccess from './redshift-endpoint-access';
export * as redshiftEndpointAuthorization from './redshift-endpoint-authorization';
export * as redshiftEventSubscription from './redshift-event-subscription';
export * as redshiftHsmClientCertificate from './redshift-hsm-client-certificate';
export * as redshiftHsmConfiguration from './redshift-hsm-configuration';
export * as redshiftLogging from './redshift-logging';
export * as redshiftParameterGroup from './redshift-parameter-group';
export * as redshiftPartner from './redshift-partner';
export * as redshiftResourcePolicy from './redshift-resource-policy';
export * as redshiftScheduledAction from './redshift-scheduled-action';
export * as redshiftSnapshotCopy from './redshift-snapshot-copy';
export * as redshiftSnapshotCopyGrant from './redshift-snapshot-copy-grant';
export * as redshiftSnapshotSchedule from './redshift-snapshot-schedule';
export * as redshiftSnapshotScheduleAssociation from './redshift-snapshot-schedule-association';
export * as redshiftSubnetGroup from './redshift-subnet-group';
export * as redshiftUsageLimit from './redshift-usage-limit';
export * as redshiftdataStatement from './redshiftdata-statement';
export * as redshiftserverlessCustomDomainAssociation from './redshiftserverless-custom-domain-association';
export * as redshiftserverlessEndpointAccess from './redshiftserverless-endpoint-access';
export * as redshiftserverlessNamespace from './redshiftserverless-namespace';
export * as redshiftserverlessResourcePolicy from './redshiftserverless-resource-policy';
export * as redshiftserverlessSnapshot from './redshiftserverless-snapshot';
export * as redshiftserverlessUsageLimit from './redshiftserverless-usage-limit';
export * as redshiftserverlessWorkgroup from './redshiftserverless-workgroup';
export * as rekognitionCollection from './rekognition-collection';
export * as rekognitionProject from './rekognition-project';
export * as resourceexplorer2Index from './resourceexplorer2-index';
export * as resourceexplorer2View from './resourceexplorer2-view';
export * as resourcegroupsGroup from './resourcegroups-group';
export * as resourcegroupsResource from './resourcegroups-resource';
export * as rolesanywhereProfile from './rolesanywhere-profile';
export * as rolesanywhereTrustAnchor from './rolesanywhere-trust-anchor';
export * as route from './route';
export * as route53CidrCollection from './route53-cidr-collection';
export * as route53CidrLocation from './route53-cidr-location';
export * as route53DelegationSet from './route53-delegation-set';
export * as route53HealthCheck from './route53-health-check';
export * as route53HostedZoneDnssec from './route53-hosted-zone-dnssec';
export * as route53KeySigningKey from './route53-key-signing-key';
export * as route53QueryLog from './route53-query-log';
export * as route53Record from './route53-record';
export * as route53ResolverConfig from './route53-resolver-config';
export * as route53ResolverDnssecConfig from './route53-resolver-dnssec-config';
export * as route53ResolverEndpoint from './route53-resolver-endpoint';
export * as route53ResolverFirewallConfig from './route53-resolver-firewall-config';
export * as route53ResolverFirewallDomainList from './route53-resolver-firewall-domain-list';
export * as route53ResolverFirewallRule from './route53-resolver-firewall-rule';
export * as route53ResolverFirewallRuleGroup from './route53-resolver-firewall-rule-group';
export * as route53ResolverFirewallRuleGroupAssociation from './route53-resolver-firewall-rule-group-association';
export * as route53ResolverQueryLogConfig from './route53-resolver-query-log-config';
export * as route53ResolverQueryLogConfigAssociation from './route53-resolver-query-log-config-association';
export * as route53ResolverRule from './route53-resolver-rule';
export * as route53ResolverRuleAssociation from './route53-resolver-rule-association';
export * as route53TrafficPolicy from './route53-traffic-policy';
export * as route53TrafficPolicyInstance from './route53-traffic-policy-instance';
export * as route53VpcAssociationAuthorization from './route53-vpc-association-authorization';
export * as route53Zone from './route53-zone';
export * as route53ZoneAssociation from './route53-zone-association';
export * as route53DomainsDelegationSignerRecord from './route53domains-delegation-signer-record';
export * as route53DomainsRegisteredDomain from './route53domains-registered-domain';
export * as route53RecoverycontrolconfigCluster from './route53recoverycontrolconfig-cluster';
export * as route53RecoverycontrolconfigControlPanel from './route53recoverycontrolconfig-control-panel';
export * as route53RecoverycontrolconfigRoutingControl from './route53recoverycontrolconfig-routing-control';
export * as route53RecoverycontrolconfigSafetyRule from './route53recoverycontrolconfig-safety-rule';
export * as route53RecoveryreadinessCell from './route53recoveryreadiness-cell';
export * as route53RecoveryreadinessReadinessCheck from './route53recoveryreadiness-readiness-check';
export * as route53RecoveryreadinessRecoveryGroup from './route53recoveryreadiness-recovery-group';
export * as route53RecoveryreadinessResourceSet from './route53recoveryreadiness-resource-set';
export * as routeTable from './route-table';
export * as routeTableAssociation from './route-table-association';
export * as rumAppMonitor from './rum-app-monitor';
export * as rumMetricsDestination from './rum-metrics-destination';
export * as s3AccessPoint from './s3-access-point';
export * as s3AccountPublicAccessBlock from './s3-account-public-access-block';
export * as s3Bucket from './s3-bucket';
export * as s3BucketAccelerateConfiguration from './s3-bucket-accelerate-configuration';
export * as s3BucketAcl from './s3-bucket-acl';
export * as s3BucketAnalyticsConfiguration from './s3-bucket-analytics-configuration';
export * as s3BucketCorsConfiguration from './s3-bucket-cors-configuration';
export * as s3BucketIntelligentTieringConfiguration from './s3-bucket-intelligent-tiering-configuration';
export * as s3BucketInventory from './s3-bucket-inventory';
export * as s3BucketLifecycleConfiguration from './s3-bucket-lifecycle-configuration';
export * as s3BucketLogging from './s3-bucket-logging';
export * as s3BucketMetric from './s3-bucket-metric';
export * as s3BucketNotification from './s3-bucket-notification';
export * as s3BucketObject from './s3-bucket-object';
export * as s3BucketObjectLockConfiguration from './s3-bucket-object-lock-configuration';
export * as s3BucketOwnershipControls from './s3-bucket-ownership-controls';
export * as s3BucketPolicy from './s3-bucket-policy';
export * as s3BucketPublicAccessBlock from './s3-bucket-public-access-block';
export * as s3BucketReplicationConfiguration from './s3-bucket-replication-configuration';
export * as s3BucketRequestPaymentConfiguration from './s3-bucket-request-payment-configuration';
export * as s3BucketServerSideEncryptionConfiguration from './s3-bucket-server-side-encryption-configuration';
export * as s3BucketVersioning from './s3-bucket-versioning';
export * as s3BucketWebsiteConfiguration from './s3-bucket-website-configuration';
export * as s3DirectoryBucket from './s3-directory-bucket';
export * as s3Object from './s3-object';
export * as s3ObjectCopy from './s3-object-copy';
export * as s3ControlAccessGrant from './s3control-access-grant';
export * as s3ControlAccessGrantsInstance from './s3control-access-grants-instance';
export * as s3ControlAccessGrantsInstanceResourcePolicy from './s3control-access-grants-instance-resource-policy';
export * as s3ControlAccessGrantsLocation from './s3control-access-grants-location';
export * as s3ControlAccessPointPolicy from './s3control-access-point-policy';
export * as s3ControlBucket from './s3control-bucket';
export * as s3ControlBucketLifecycleConfiguration from './s3control-bucket-lifecycle-configuration';
export * as s3ControlBucketPolicy from './s3control-bucket-policy';
export * as s3ControlMultiRegionAccessPoint from './s3control-multi-region-access-point';
export * as s3ControlMultiRegionAccessPointPolicy from './s3control-multi-region-access-point-policy';
export * as s3ControlObjectLambdaAccessPoint from './s3control-object-lambda-access-point';
export * as s3ControlObjectLambdaAccessPointPolicy from './s3control-object-lambda-access-point-policy';
export * as s3ControlStorageLensConfiguration from './s3control-storage-lens-configuration';
export * as s3OutpostsEndpoint from './s3outposts-endpoint';
export * as sagemakerApp from './sagemaker-app';
export * as sagemakerAppImageConfig from './sagemaker-app-image-config';
export * as sagemakerCodeRepository from './sagemaker-code-repository';
export * as sagemakerDataQualityJobDefinition from './sagemaker-data-quality-job-definition';
export * as sagemakerDevice from './sagemaker-device';
export * as sagemakerDeviceFleet from './sagemaker-device-fleet';
export * as sagemakerDomain from './sagemaker-domain';
export * as sagemakerEndpoint from './sagemaker-endpoint';
export * as sagemakerEndpointConfiguration from './sagemaker-endpoint-configuration';
export * as sagemakerFeatureGroup from './sagemaker-feature-group';
export * as sagemakerFlowDefinition from './sagemaker-flow-definition';
export * as sagemakerHumanTaskUi from './sagemaker-human-task-ui';
export * as sagemakerImage from './sagemaker-image';
export * as sagemakerImageVersion from './sagemaker-image-version';
export * as sagemakerModel from './sagemaker-model';
export * as sagemakerModelPackageGroup from './sagemaker-model-package-group';
export * as sagemakerModelPackageGroupPolicy from './sagemaker-model-package-group-policy';
export * as sagemakerMonitoringSchedule from './sagemaker-monitoring-schedule';
export * as sagemakerNotebookInstance from './sagemaker-notebook-instance';
export * as sagemakerNotebookInstanceLifecycleConfiguration from './sagemaker-notebook-instance-lifecycle-configuration';
export * as sagemakerPipeline from './sagemaker-pipeline';
export * as sagemakerProject from './sagemaker-project';
export * as sagemakerServicecatalogPortfolioStatus from './sagemaker-servicecatalog-portfolio-status';
export * as sagemakerSpace from './sagemaker-space';
export * as sagemakerStudioLifecycleConfig from './sagemaker-studio-lifecycle-config';
export * as sagemakerUserProfile from './sagemaker-user-profile';
export * as sagemakerWorkforce from './sagemaker-workforce';
export * as sagemakerWorkteam from './sagemaker-workteam';
export * as schedulerSchedule from './scheduler-schedule';
export * as schedulerScheduleGroup from './scheduler-schedule-group';
export * as schemasDiscoverer from './schemas-discoverer';
export * as schemasRegistry from './schemas-registry';
export * as schemasRegistryPolicy from './schemas-registry-policy';
export * as schemasSchema from './schemas-schema';
export * as secretsmanagerSecret from './secretsmanager-secret';
export * as secretsmanagerSecretPolicy from './secretsmanager-secret-policy';
export * as secretsmanagerSecretRotation from './secretsmanager-secret-rotation';
export * as secretsmanagerSecretVersion from './secretsmanager-secret-version';
export * as securityGroup from './security-group';
export * as securityGroupRule from './security-group-rule';
export * as securityhubAccount from './securityhub-account';
export * as securityhubActionTarget from './securityhub-action-target';
export * as securityhubAutomationRule from './securityhub-automation-rule';
export * as securityhubConfigurationPolicy from './securityhub-configuration-policy';
export * as securityhubConfigurationPolicyAssociation from './securityhub-configuration-policy-association';
export * as securityhubFindingAggregator from './securityhub-finding-aggregator';
export * as securityhubInsight from './securityhub-insight';
export * as securityhubInviteAccepter from './securityhub-invite-accepter';
export * as securityhubMember from './securityhub-member';
export * as securityhubOrganizationAdminAccount from './securityhub-organization-admin-account';
export * as securityhubOrganizationConfiguration from './securityhub-organization-configuration';
export * as securityhubProductSubscription from './securityhub-product-subscription';
export * as securityhubStandardsControl from './securityhub-standards-control';
export * as securityhubStandardsSubscription from './securityhub-standards-subscription';
export * as securitylakeAwsLogSource from './securitylake-aws-log-source';
export * as securitylakeCustomLogSource from './securitylake-custom-log-source';
export * as securitylakeDataLake from './securitylake-data-lake';
export * as securitylakeSubscriber from './securitylake-subscriber';
export * as securitylakeSubscriberNotification from './securitylake-subscriber-notification';
export * as serverlessapplicationrepositoryCloudformationStack from './serverlessapplicationrepository-cloudformation-stack';
export * as serviceDiscoveryHttpNamespace from './service-discovery-http-namespace';
export * as serviceDiscoveryInstance from './service-discovery-instance';
export * as serviceDiscoveryPrivateDnsNamespace from './service-discovery-private-dns-namespace';
export * as serviceDiscoveryPublicDnsNamespace from './service-discovery-public-dns-namespace';
export * as serviceDiscoveryService from './service-discovery-service';
export * as servicecatalogBudgetResourceAssociation from './servicecatalog-budget-resource-association';
export * as servicecatalogConstraint from './servicecatalog-constraint';
export * as servicecatalogOrganizationsAccess from './servicecatalog-organizations-access';
export * as servicecatalogPortfolio from './servicecatalog-portfolio';
export * as servicecatalogPortfolioShare from './servicecatalog-portfolio-share';
export * as servicecatalogPrincipalPortfolioAssociation from './servicecatalog-principal-portfolio-association';
export * as servicecatalogProduct from './servicecatalog-product';
export * as servicecatalogProductPortfolioAssociation from './servicecatalog-product-portfolio-association';
export * as servicecatalogProvisionedProduct from './servicecatalog-provisioned-product';
export * as servicecatalogProvisioningArtifact from './servicecatalog-provisioning-artifact';
export * as servicecatalogServiceAction from './servicecatalog-service-action';
export * as servicecatalogTagOption from './servicecatalog-tag-option';
export * as servicecatalogTagOptionResourceAssociation from './servicecatalog-tag-option-resource-association';
export * as servicecatalogappregistryApplication from './servicecatalogappregistry-application';
export * as servicequotasServiceQuota from './servicequotas-service-quota';
export * as servicequotasTemplate from './servicequotas-template';
export * as servicequotasTemplateAssociation from './servicequotas-template-association';
export * as sesActiveReceiptRuleSet from './ses-active-receipt-rule-set';
export * as sesConfigurationSet from './ses-configuration-set';
export * as sesDomainDkim from './ses-domain-dkim';
export * as sesDomainIdentity from './ses-domain-identity';
export * as sesDomainIdentityVerification from './ses-domain-identity-verification';
export * as sesDomainMailFrom from './ses-domain-mail-from';
export * as sesEmailIdentity from './ses-email-identity';
export * as sesEventDestination from './ses-event-destination';
export * as sesIdentityNotificationTopic from './ses-identity-notification-topic';
export * as sesIdentityPolicy from './ses-identity-policy';
export * as sesReceiptFilter from './ses-receipt-filter';
export * as sesReceiptRule from './ses-receipt-rule';
export * as sesReceiptRuleSet from './ses-receipt-rule-set';
export * as sesTemplate from './ses-template';
export * as sesv2AccountVdmAttributes from './sesv2-account-vdm-attributes';
export * as sesv2ConfigurationSet from './sesv2-configuration-set';
export * as sesv2ConfigurationSetEventDestination from './sesv2-configuration-set-event-destination';
export * as sesv2ContactList from './sesv2-contact-list';
export * as sesv2DedicatedIpAssignment from './sesv2-dedicated-ip-assignment';
export * as sesv2DedicatedIpPool from './sesv2-dedicated-ip-pool';
export * as sesv2EmailIdentity from './sesv2-email-identity';
export * as sesv2EmailIdentityFeedbackAttributes from './sesv2-email-identity-feedback-attributes';
export * as sesv2EmailIdentityMailFromAttributes from './sesv2-email-identity-mail-from-attributes';
export * as sesv2EmailIdentityPolicy from './sesv2-email-identity-policy';
export * as sfnActivity from './sfn-activity';
export * as sfnAlias from './sfn-alias';
export * as sfnStateMachine from './sfn-state-machine';
export * as shieldApplicationLayerAutomaticResponse from './shield-application-layer-automatic-response';
export * as shieldDrtAccessLogBucketAssociation from './shield-drt-access-log-bucket-association';
export * as shieldDrtAccessRoleArnAssociation from './shield-drt-access-role-arn-association';
export * as shieldProactiveEngagement from './shield-proactive-engagement';
export * as shieldProtection from './shield-protection';
export * as shieldProtectionGroup from './shield-protection-group';
export * as shieldProtectionHealthCheckAssociation from './shield-protection-health-check-association';
export * as signerSigningJob from './signer-signing-job';
export * as signerSigningProfile from './signer-signing-profile';
export * as signerSigningProfilePermission from './signer-signing-profile-permission';
export * as simpledbDomain from './simpledb-domain';
export * as snapshotCreateVolumePermission from './snapshot-create-volume-permission';
export * as snsPlatformApplication from './sns-platform-application';
export * as snsSmsPreferences from './sns-sms-preferences';
export * as snsTopic from './sns-topic';
export * as snsTopicDataProtectionPolicy from './sns-topic-data-protection-policy';
export * as snsTopicPolicy from './sns-topic-policy';
export * as snsTopicSubscription from './sns-topic-subscription';
export * as spotDatafeedSubscription from './spot-datafeed-subscription';
export * as spotFleetRequest from './spot-fleet-request';
export * as spotInstanceRequest from './spot-instance-request';
export * as sqsQueue from './sqs-queue';
export * as sqsQueuePolicy from './sqs-queue-policy';
export * as sqsQueueRedriveAllowPolicy from './sqs-queue-redrive-allow-policy';
export * as sqsQueueRedrivePolicy from './sqs-queue-redrive-policy';
export * as ssmActivation from './ssm-activation';
export * as ssmAssociation from './ssm-association';
export * as ssmDefaultPatchBaseline from './ssm-default-patch-baseline';
export * as ssmDocument from './ssm-document';
export * as ssmMaintenanceWindow from './ssm-maintenance-window';
export * as ssmMaintenanceWindowTarget from './ssm-maintenance-window-target';
export * as ssmMaintenanceWindowTask from './ssm-maintenance-window-task';
export * as ssmParameter from './ssm-parameter';
export * as ssmPatchBaseline from './ssm-patch-baseline';
export * as ssmPatchGroup from './ssm-patch-group';
export * as ssmResourceDataSync from './ssm-resource-data-sync';
export * as ssmServiceSetting from './ssm-service-setting';
export * as ssmcontactsContact from './ssmcontacts-contact';
export * as ssmcontactsContactChannel from './ssmcontacts-contact-channel';
export * as ssmcontactsPlan from './ssmcontacts-plan';
export * as ssmcontactsRotation from './ssmcontacts-rotation';
export * as ssmincidentsReplicationSet from './ssmincidents-replication-set';
export * as ssmincidentsResponsePlan from './ssmincidents-response-plan';
export * as ssoadminAccountAssignment from './ssoadmin-account-assignment';
export * as ssoadminApplication from './ssoadmin-application';
export * as ssoadminApplicationAccessScope from './ssoadmin-application-access-scope';
export * as ssoadminApplicationAssignment from './ssoadmin-application-assignment';
export * as ssoadminApplicationAssignmentConfiguration from './ssoadmin-application-assignment-configuration';
export * as ssoadminCustomerManagedPolicyAttachment from './ssoadmin-customer-managed-policy-attachment';
export * as ssoadminInstanceAccessControlAttributes from './ssoadmin-instance-access-control-attributes';
export * as ssoadminManagedPolicyAttachment from './ssoadmin-managed-policy-attachment';
export * as ssoadminPermissionSet from './ssoadmin-permission-set';
export * as ssoadminPermissionSetInlinePolicy from './ssoadmin-permission-set-inline-policy';
export * as ssoadminPermissionsBoundaryAttachment from './ssoadmin-permissions-boundary-attachment';
export * as ssoadminTrustedTokenIssuer from './ssoadmin-trusted-token-issuer';
export * as storagegatewayCache from './storagegateway-cache';
export * as storagegatewayCachedIscsiVolume from './storagegateway-cached-iscsi-volume';
export * as storagegatewayFileSystemAssociation from './storagegateway-file-system-association';
export * as storagegatewayGateway from './storagegateway-gateway';
export * as storagegatewayNfsFileShare from './storagegateway-nfs-file-share';
export * as storagegatewaySmbFileShare from './storagegateway-smb-file-share';
export * as storagegatewayStoredIscsiVolume from './storagegateway-stored-iscsi-volume';
export * as storagegatewayTapePool from './storagegateway-tape-pool';
export * as storagegatewayUploadBuffer from './storagegateway-upload-buffer';
export * as storagegatewayWorkingStorage from './storagegateway-working-storage';
export * as subnet from './subnet';
export * as swfDomain from './swf-domain';
export * as syntheticsCanary from './synthetics-canary';
export * as syntheticsGroup from './synthetics-group';
export * as syntheticsGroupAssociation from './synthetics-group-association';
export * as timestreamwriteDatabase from './timestreamwrite-database';
export * as timestreamwriteTable from './timestreamwrite-table';
export * as transcribeLanguageModel from './transcribe-language-model';
export * as transcribeMedicalVocabulary from './transcribe-medical-vocabulary';
export * as transcribeVocabulary from './transcribe-vocabulary';
export * as transcribeVocabularyFilter from './transcribe-vocabulary-filter';
export * as transferAccess from './transfer-access';
export * as transferAgreement from './transfer-agreement';
export * as transferCertificate from './transfer-certificate';
export * as transferConnector from './transfer-connector';
export * as transferProfile from './transfer-profile';
export * as transferServer from './transfer-server';
export * as transferSshKey from './transfer-ssh-key';
export * as transferTag from './transfer-tag';
export * as transferUser from './transfer-user';
export * as transferWorkflow from './transfer-workflow';
export * as verifiedaccessEndpoint from './verifiedaccess-endpoint';
export * as verifiedaccessGroup from './verifiedaccess-group';
export * as verifiedaccessInstance from './verifiedaccess-instance';
export * as verifiedaccessInstanceLoggingConfiguration from './verifiedaccess-instance-logging-configuration';
export * as verifiedaccessInstanceTrustProviderAttachment from './verifiedaccess-instance-trust-provider-attachment';
export * as verifiedaccessTrustProvider from './verifiedaccess-trust-provider';
export * as verifiedpermissionsPolicy from './verifiedpermissions-policy';
export * as verifiedpermissionsPolicyStore from './verifiedpermissions-policy-store';
export * as verifiedpermissionsPolicyTemplate from './verifiedpermissions-policy-template';
export * as verifiedpermissionsSchema from './verifiedpermissions-schema';
export * as volumeAttachment from './volume-attachment';
export * as vpc from './vpc';
export * as vpcDhcpOptions from './vpc-dhcp-options';
export * as vpcDhcpOptionsAssociation from './vpc-dhcp-options-association';
export * as vpcEndpoint from './vpc-endpoint';
export * as vpcEndpointConnectionAccepter from './vpc-endpoint-connection-accepter';
export * as vpcEndpointConnectionNotification from './vpc-endpoint-connection-notification';
export * as vpcEndpointPolicy from './vpc-endpoint-policy';
export * as vpcEndpointRouteTableAssociation from './vpc-endpoint-route-table-association';
export * as vpcEndpointSecurityGroupAssociation from './vpc-endpoint-security-group-association';
export * as vpcEndpointService from './vpc-endpoint-service';
export * as vpcEndpointServiceAllowedPrincipal from './vpc-endpoint-service-allowed-principal';
export * as vpcEndpointSubnetAssociation from './vpc-endpoint-subnet-association';
export * as vpcIpam from './vpc-ipam';
export * as vpcIpamOrganizationAdminAccount from './vpc-ipam-organization-admin-account';
export * as vpcIpamPool from './vpc-ipam-pool';
export * as vpcIpamPoolCidr from './vpc-ipam-pool-cidr';
export * as vpcIpamPoolCidrAllocation from './vpc-ipam-pool-cidr-allocation';
export * as vpcIpamPreviewNextCidr from './vpc-ipam-preview-next-cidr';
export * as vpcIpamResourceDiscovery from './vpc-ipam-resource-discovery';
export * as vpcIpamResourceDiscoveryAssociation from './vpc-ipam-resource-discovery-association';
export * as vpcIpamScope from './vpc-ipam-scope';
export * as vpcIpv4CidrBlockAssociation from './vpc-ipv4-cidr-block-association';
export * as vpcIpv6CidrBlockAssociation from './vpc-ipv6-cidr-block-association';
export * as vpcNetworkPerformanceMetricSubscription from './vpc-network-performance-metric-subscription';
export * as vpcPeeringConnection from './vpc-peering-connection';
export * as vpcPeeringConnectionAccepter from './vpc-peering-connection-accepter';
export * as vpcPeeringConnectionOptions from './vpc-peering-connection-options';
export * as vpcSecurityGroupEgressRule from './vpc-security-group-egress-rule';
export * as vpcSecurityGroupIngressRule from './vpc-security-group-ingress-rule';
export * as vpclatticeAccessLogSubscription from './vpclattice-access-log-subscription';
export * as vpclatticeAuthPolicy from './vpclattice-auth-policy';
export * as vpclatticeListener from './vpclattice-listener';
export * as vpclatticeListenerRule from './vpclattice-listener-rule';
export * as vpclatticeResourcePolicy from './vpclattice-resource-policy';
export * as vpclatticeService from './vpclattice-service';
export * as vpclatticeServiceNetwork from './vpclattice-service-network';
export * as vpclatticeServiceNetworkServiceAssociation from './vpclattice-service-network-service-association';
export * as vpclatticeServiceNetworkVpcAssociation from './vpclattice-service-network-vpc-association';
export * as vpclatticeTargetGroup from './vpclattice-target-group';
export * as vpclatticeTargetGroupAttachment from './vpclattice-target-group-attachment';
export * as vpnConnection from './vpn-connection';
export * as vpnConnectionRoute from './vpn-connection-route';
export * as vpnGateway from './vpn-gateway';
export * as vpnGatewayAttachment from './vpn-gateway-attachment';
export * as vpnGatewayRoutePropagation from './vpn-gateway-route-propagation';
export * as wafByteMatchSet from './waf-byte-match-set';
export * as wafGeoMatchSet from './waf-geo-match-set';
export * as wafIpset from './waf-ipset';
export * as wafRateBasedRule from './waf-rate-based-rule';
export * as wafRegexMatchSet from './waf-regex-match-set';
export * as wafRegexPatternSet from './waf-regex-pattern-set';
export * as wafRule from './waf-rule';
export * as wafRuleGroup from './waf-rule-group';
export * as wafSizeConstraintSet from './waf-size-constraint-set';
export * as wafSqlInjectionMatchSet from './waf-sql-injection-match-set';
export * as wafWebAcl from './waf-web-acl';
export * as wafXssMatchSet from './waf-xss-match-set';
export * as wafregionalByteMatchSet from './wafregional-byte-match-set';
export * as wafregionalGeoMatchSet from './wafregional-geo-match-set';
export * as wafregionalIpset from './wafregional-ipset';
export * as wafregionalRateBasedRule from './wafregional-rate-based-rule';
export * as wafregionalRegexMatchSet from './wafregional-regex-match-set';
export * as wafregionalRegexPatternSet from './wafregional-regex-pattern-set';
export * as wafregionalRule from './wafregional-rule';
export * as wafregionalRuleGroup from './wafregional-rule-group';
export * as wafregionalSizeConstraintSet from './wafregional-size-constraint-set';
export * as wafregionalSqlInjectionMatchSet from './wafregional-sql-injection-match-set';
export * as wafregionalWebAcl from './wafregional-web-acl';
export * as wafregionalWebAclAssociation from './wafregional-web-acl-association';
export * as wafregionalXssMatchSet from './wafregional-xss-match-set';
export * as wafv2IpSet from './wafv2-ip-set';
export * as wafv2RegexPatternSet from './wafv2-regex-pattern-set';
export * as wafv2RuleGroup from './wafv2-rule-group';
export * as wafv2WebAcl from './wafv2-web-acl';
export * as wafv2WebAclAssociation from './wafv2-web-acl-association';
export * as wafv2WebAclLoggingConfiguration from './wafv2-web-acl-logging-configuration';
export * as worklinkFleet from './worklink-fleet';
export * as worklinkWebsiteCertificateAuthorityAssociation from './worklink-website-certificate-authority-association';
export * as workspacesConnectionAlias from './workspaces-connection-alias';
export * as workspacesDirectory from './workspaces-directory';
export * as workspacesIpGroup from './workspaces-ip-group';
export * as workspacesWorkspace from './workspaces-workspace';
export * as xrayEncryptionConfig from './xray-encryption-config';
export * as xrayGroup from './xray-group';
export * as xraySamplingRule from './xray-sampling-rule';
export * as dataAwsAcmCertificate from './data-aws-acm-certificate';
export * as dataAwsAcmpcaCertificate from './data-aws-acmpca-certificate';
export * as dataAwsAcmpcaCertificateAuthority from './data-aws-acmpca-certificate-authority';
export * as dataAwsAlb from './data-aws-alb';
export * as dataAwsAlbListener from './data-aws-alb-listener';
export * as dataAwsAlbTargetGroup from './data-aws-alb-target-group';
export * as dataAwsAmi from './data-aws-ami';
export * as dataAwsAmiIds from './data-aws-ami-ids';
export * as dataAwsApiGatewayApiKey from './data-aws-api-gateway-api-key';
export * as dataAwsApiGatewayAuthorizer from './data-aws-api-gateway-authorizer';
export * as dataAwsApiGatewayAuthorizers from './data-aws-api-gateway-authorizers';
export * as dataAwsApiGatewayDomainName from './data-aws-api-gateway-domain-name';
export * as dataAwsApiGatewayExport from './data-aws-api-gateway-export';
export * as dataAwsApiGatewayResource from './data-aws-api-gateway-resource';
export * as dataAwsApiGatewayRestApi from './data-aws-api-gateway-rest-api';
export * as dataAwsApiGatewaySdk from './data-aws-api-gateway-sdk';
export * as dataAwsApiGatewayVpcLink from './data-aws-api-gateway-vpc-link';
export * as dataAwsApigatewayv2Api from './data-aws-apigatewayv2-api';
export * as dataAwsApigatewayv2Apis from './data-aws-apigatewayv2-apis';
export * as dataAwsApigatewayv2Export from './data-aws-apigatewayv2-export';
export * as dataAwsApigatewayv2VpcLink from './data-aws-apigatewayv2-vpc-link';
export * as dataAwsAppconfigConfigurationProfile from './data-aws-appconfig-configuration-profile';
export * as dataAwsAppconfigConfigurationProfiles from './data-aws-appconfig-configuration-profiles';
export * as dataAwsAppconfigEnvironment from './data-aws-appconfig-environment';
export * as dataAwsAppconfigEnvironments from './data-aws-appconfig-environments';
export * as dataAwsAppintegrationsEventIntegration from './data-aws-appintegrations-event-integration';
export * as dataAwsAppmeshGatewayRoute from './data-aws-appmesh-gateway-route';
export * as dataAwsAppmeshMesh from './data-aws-appmesh-mesh';
export * as dataAwsAppmeshRoute from './data-aws-appmesh-route';
export * as dataAwsAppmeshVirtualGateway from './data-aws-appmesh-virtual-gateway';
export * as dataAwsAppmeshVirtualNode from './data-aws-appmesh-virtual-node';
export * as dataAwsAppmeshVirtualRouter from './data-aws-appmesh-virtual-router';
export * as dataAwsAppmeshVirtualService from './data-aws-appmesh-virtual-service';
export * as dataAwsApprunnerHostedZoneId from './data-aws-apprunner-hosted-zone-id';
export * as dataAwsArn from './data-aws-arn';
export * as dataAwsAthenaNamedQuery from './data-aws-athena-named-query';
export * as dataAwsAuditmanagerControl from './data-aws-auditmanager-control';
export * as dataAwsAuditmanagerFramework from './data-aws-auditmanager-framework';
export * as dataAwsAutoscalingGroup from './data-aws-autoscaling-group';
export * as dataAwsAutoscalingGroups from './data-aws-autoscaling-groups';
export * as dataAwsAvailabilityZone from './data-aws-availability-zone';
export * as dataAwsAvailabilityZones from './data-aws-availability-zones';
export * as dataAwsBackupFramework from './data-aws-backup-framework';
export * as dataAwsBackupPlan from './data-aws-backup-plan';
export * as dataAwsBackupReportPlan from './data-aws-backup-report-plan';
export * as dataAwsBackupSelection from './data-aws-backup-selection';
export * as dataAwsBackupVault from './data-aws-backup-vault';
export * as dataAwsBatchComputeEnvironment from './data-aws-batch-compute-environment';
export * as dataAwsBatchJobDefinition from './data-aws-batch-job-definition';
export * as dataAwsBatchJobQueue from './data-aws-batch-job-queue';
export * as dataAwsBatchSchedulingPolicy from './data-aws-batch-scheduling-policy';
export * as dataAwsBedrockCustomModel from './data-aws-bedrock-custom-model';
export * as dataAwsBedrockCustomModels from './data-aws-bedrock-custom-models';
export * as dataAwsBedrockFoundationModel from './data-aws-bedrock-foundation-model';
export * as dataAwsBedrockFoundationModels from './data-aws-bedrock-foundation-models';
export * as dataAwsBillingServiceAccount from './data-aws-billing-service-account';
export * as dataAwsBudgetsBudget from './data-aws-budgets-budget';
export * as dataAwsCallerIdentity from './data-aws-caller-identity';
export * as dataAwsCanonicalUserId from './data-aws-canonical-user-id';
export * as dataAwsCeCostCategory from './data-aws-ce-cost-category';
export * as dataAwsCeTags from './data-aws-ce-tags';
export * as dataAwsCloudcontrolapiResource from './data-aws-cloudcontrolapi-resource';
export * as dataAwsCloudformationExport from './data-aws-cloudformation-export';
export * as dataAwsCloudformationStack from './data-aws-cloudformation-stack';
export * as dataAwsCloudformationType from './data-aws-cloudformation-type';
export * as dataAwsCloudfrontCachePolicy from './data-aws-cloudfront-cache-policy';
export * as dataAwsCloudfrontDistribution from './data-aws-cloudfront-distribution';
export * as dataAwsCloudfrontFunction from './data-aws-cloudfront-function';
export * as dataAwsCloudfrontLogDeliveryCanonicalUserId from './data-aws-cloudfront-log-delivery-canonical-user-id';
export * as dataAwsCloudfrontOriginAccessIdentities from './data-aws-cloudfront-origin-access-identities';
export * as dataAwsCloudfrontOriginAccessIdentity from './data-aws-cloudfront-origin-access-identity';
export * as dataAwsCloudfrontOriginRequestPolicy from './data-aws-cloudfront-origin-request-policy';
export * as dataAwsCloudfrontRealtimeLogConfig from './data-aws-cloudfront-realtime-log-config';
export * as dataAwsCloudfrontResponseHeadersPolicy from './data-aws-cloudfront-response-headers-policy';
export * as dataAwsCloudhsmV2Cluster from './data-aws-cloudhsm-v2-cluster';
export * as dataAwsCloudtrailServiceAccount from './data-aws-cloudtrail-service-account';
export * as dataAwsCloudwatchEventBus from './data-aws-cloudwatch-event-bus';
export * as dataAwsCloudwatchEventConnection from './data-aws-cloudwatch-event-connection';
export * as dataAwsCloudwatchEventSource from './data-aws-cloudwatch-event-source';
export * as dataAwsCloudwatchLogDataProtectionPolicyDocument from './data-aws-cloudwatch-log-data-protection-policy-document';
export * as dataAwsCloudwatchLogGroup from './data-aws-cloudwatch-log-group';
export * as dataAwsCloudwatchLogGroups from './data-aws-cloudwatch-log-groups';
export * as dataAwsCodeartifactAuthorizationToken from './data-aws-codeartifact-authorization-token';
export * as dataAwsCodeartifactRepositoryEndpoint from './data-aws-codeartifact-repository-endpoint';
export * as dataAwsCodecatalystDevEnvironment from './data-aws-codecatalyst-dev-environment';
export * as dataAwsCodecommitApprovalRuleTemplate from './data-aws-codecommit-approval-rule-template';
export * as dataAwsCodecommitRepository from './data-aws-codecommit-repository';
export * as dataAwsCodeguruprofilerProfilingGroup from './data-aws-codeguruprofiler-profiling-group';
export * as dataAwsCodestarconnectionsConnection from './data-aws-codestarconnections-connection';
export * as dataAwsCognitoIdentityPool from './data-aws-cognito-identity-pool';
export * as dataAwsCognitoUserGroup from './data-aws-cognito-user-group';
export * as dataAwsCognitoUserGroups from './data-aws-cognito-user-groups';
export * as dataAwsCognitoUserPoolClient from './data-aws-cognito-user-pool-client';
export * as dataAwsCognitoUserPoolClients from './data-aws-cognito-user-pool-clients';
export * as dataAwsCognitoUserPoolSigningCertificate from './data-aws-cognito-user-pool-signing-certificate';
export * as dataAwsCognitoUserPools from './data-aws-cognito-user-pools';
export * as dataAwsConnectBotAssociation from './data-aws-connect-bot-association';
export * as dataAwsConnectContactFlow from './data-aws-connect-contact-flow';
export * as dataAwsConnectContactFlowModule from './data-aws-connect-contact-flow-module';
export * as dataAwsConnectHoursOfOperation from './data-aws-connect-hours-of-operation';
export * as dataAwsConnectInstance from './data-aws-connect-instance';
export * as dataAwsConnectInstanceStorageConfig from './data-aws-connect-instance-storage-config';
export * as dataAwsConnectLambdaFunctionAssociation from './data-aws-connect-lambda-function-association';
export * as dataAwsConnectPrompt from './data-aws-connect-prompt';
export * as dataAwsConnectQueue from './data-aws-connect-queue';
export * as dataAwsConnectQuickConnect from './data-aws-connect-quick-connect';
export * as dataAwsConnectRoutingProfile from './data-aws-connect-routing-profile';
export * as dataAwsConnectSecurityProfile from './data-aws-connect-security-profile';
export * as dataAwsConnectUser from './data-aws-connect-user';
export * as dataAwsConnectUserHierarchyGroup from './data-aws-connect-user-hierarchy-group';
export * as dataAwsConnectUserHierarchyStructure from './data-aws-connect-user-hierarchy-structure';
export * as dataAwsConnectVocabulary from './data-aws-connect-vocabulary';
export * as dataAwsControltowerControls from './data-aws-controltower-controls';
export * as dataAwsCurReportDefinition from './data-aws-cur-report-definition';
export * as dataAwsCustomerGateway from './data-aws-customer-gateway';
export * as dataAwsDatapipelinePipeline from './data-aws-datapipeline-pipeline';
export * as dataAwsDatapipelinePipelineDefinition from './data-aws-datapipeline-pipeline-definition';
export * as dataAwsDbClusterSnapshot from './data-aws-db-cluster-snapshot';
export * as dataAwsDbEventCategories from './data-aws-db-event-categories';
export * as dataAwsDbInstance from './data-aws-db-instance';
export * as dataAwsDbInstances from './data-aws-db-instances';
export * as dataAwsDbParameterGroup from './data-aws-db-parameter-group';
export * as dataAwsDbProxy from './data-aws-db-proxy';
export * as dataAwsDbSnapshot from './data-aws-db-snapshot';
export * as dataAwsDbSubnetGroup from './data-aws-db-subnet-group';
export * as dataAwsDefaultTags from './data-aws-default-tags';
export * as dataAwsDevopsguruNotificationChannel from './data-aws-devopsguru-notification-channel';
export * as dataAwsDevopsguruResourceCollection from './data-aws-devopsguru-resource-collection';
export * as dataAwsDirectoryServiceDirectory from './data-aws-directory-service-directory';
export * as dataAwsDmsCertificate from './data-aws-dms-certificate';
export * as dataAwsDmsEndpoint from './data-aws-dms-endpoint';
export * as dataAwsDmsReplicationInstance from './data-aws-dms-replication-instance';
export * as dataAwsDmsReplicationSubnetGroup from './data-aws-dms-replication-subnet-group';
export * as dataAwsDmsReplicationTask from './data-aws-dms-replication-task';
export * as dataAwsDocdbEngineVersion from './data-aws-docdb-engine-version';
export * as dataAwsDocdbOrderableDbInstance from './data-aws-docdb-orderable-db-instance';
export * as dataAwsDxConnection from './data-aws-dx-connection';
export * as dataAwsDxGateway from './data-aws-dx-gateway';
export * as dataAwsDxLocation from './data-aws-dx-location';
export * as dataAwsDxLocations from './data-aws-dx-locations';
export * as dataAwsDxRouterConfiguration from './data-aws-dx-router-configuration';
export * as dataAwsDynamodbTable from './data-aws-dynamodb-table';
export * as dataAwsDynamodbTableItem from './data-aws-dynamodb-table-item';
export * as dataAwsEbsDefaultKmsKey from './data-aws-ebs-default-kms-key';
export * as dataAwsEbsEncryptionByDefault from './data-aws-ebs-encryption-by-default';
export * as dataAwsEbsSnapshot from './data-aws-ebs-snapshot';
export * as dataAwsEbsSnapshotIds from './data-aws-ebs-snapshot-ids';
export * as dataAwsEbsVolume from './data-aws-ebs-volume';
export * as dataAwsEbsVolumes from './data-aws-ebs-volumes';
export * as dataAwsEc2ClientVpnEndpoint from './data-aws-ec2-client-vpn-endpoint';
export * as dataAwsEc2CoipPool from './data-aws-ec2-coip-pool';
export * as dataAwsEc2CoipPools from './data-aws-ec2-coip-pools';
export * as dataAwsEc2Host from './data-aws-ec2-host';
export * as dataAwsEc2InstanceType from './data-aws-ec2-instance-type';
export * as dataAwsEc2InstanceTypeOffering from './data-aws-ec2-instance-type-offering';
export * as dataAwsEc2InstanceTypeOfferings from './data-aws-ec2-instance-type-offerings';
export * as dataAwsEc2InstanceTypes from './data-aws-ec2-instance-types';
export * as dataAwsEc2LocalGateway from './data-aws-ec2-local-gateway';
export * as dataAwsEc2LocalGatewayRouteTable from './data-aws-ec2-local-gateway-route-table';
export * as dataAwsEc2LocalGatewayRouteTables from './data-aws-ec2-local-gateway-route-tables';
export * as dataAwsEc2LocalGatewayVirtualInterface from './data-aws-ec2-local-gateway-virtual-interface';
export * as dataAwsEc2LocalGatewayVirtualInterfaceGroup from './data-aws-ec2-local-gateway-virtual-interface-group';
export * as dataAwsEc2LocalGatewayVirtualInterfaceGroups from './data-aws-ec2-local-gateway-virtual-interface-groups';
export * as dataAwsEc2LocalGateways from './data-aws-ec2-local-gateways';
export * as dataAwsEc2ManagedPrefixList from './data-aws-ec2-managed-prefix-list';
export * as dataAwsEc2ManagedPrefixLists from './data-aws-ec2-managed-prefix-lists';
export * as dataAwsEc2NetworkInsightsAnalysis from './data-aws-ec2-network-insights-analysis';
export * as dataAwsEc2NetworkInsightsPath from './data-aws-ec2-network-insights-path';
export * as dataAwsEc2PublicIpv4Pool from './data-aws-ec2-public-ipv4-pool';
export * as dataAwsEc2PublicIpv4Pools from './data-aws-ec2-public-ipv4-pools';
export * as dataAwsEc2SerialConsoleAccess from './data-aws-ec2-serial-console-access';
export * as dataAwsEc2SpotPrice from './data-aws-ec2-spot-price';
export * as dataAwsEc2TransitGateway from './data-aws-ec2-transit-gateway';
export * as dataAwsEc2TransitGatewayAttachment from './data-aws-ec2-transit-gateway-attachment';
export * as dataAwsEc2TransitGatewayAttachments from './data-aws-ec2-transit-gateway-attachments';
export * as dataAwsEc2TransitGatewayConnect from './data-aws-ec2-transit-gateway-connect';
export * as dataAwsEc2TransitGatewayConnectPeer from './data-aws-ec2-transit-gateway-connect-peer';
export * as dataAwsEc2TransitGatewayDxGatewayAttachment from './data-aws-ec2-transit-gateway-dx-gateway-attachment';
export * as dataAwsEc2TransitGatewayMulticastDomain from './data-aws-ec2-transit-gateway-multicast-domain';
export * as dataAwsEc2TransitGatewayPeeringAttachment from './data-aws-ec2-transit-gateway-peering-attachment';
export * as dataAwsEc2TransitGatewayRouteTable from './data-aws-ec2-transit-gateway-route-table';
export * as dataAwsEc2TransitGatewayRouteTableAssociations from './data-aws-ec2-transit-gateway-route-table-associations';
export * as dataAwsEc2TransitGatewayRouteTablePropagations from './data-aws-ec2-transit-gateway-route-table-propagations';
export * as dataAwsEc2TransitGatewayRouteTableRoutes from './data-aws-ec2-transit-gateway-route-table-routes';
export * as dataAwsEc2TransitGatewayRouteTables from './data-aws-ec2-transit-gateway-route-tables';
export * as dataAwsEc2TransitGatewayVpcAttachment from './data-aws-ec2-transit-gateway-vpc-attachment';
export * as dataAwsEc2TransitGatewayVpcAttachments from './data-aws-ec2-transit-gateway-vpc-attachments';
export * as dataAwsEc2TransitGatewayVpnAttachment from './data-aws-ec2-transit-gateway-vpn-attachment';
export * as dataAwsEcrAuthorizationToken from './data-aws-ecr-authorization-token';
export * as dataAwsEcrImage from './data-aws-ecr-image';
export * as dataAwsEcrLifecyclePolicyDocument from './data-aws-ecr-lifecycle-policy-document';
export * as dataAwsEcrPullThroughCacheRule from './data-aws-ecr-pull-through-cache-rule';
export * as dataAwsEcrRepositories from './data-aws-ecr-repositories';
export * as dataAwsEcrRepository from './data-aws-ecr-repository';
export * as dataAwsEcrpublicAuthorizationToken from './data-aws-ecrpublic-authorization-token';
export * as dataAwsEcsCluster from './data-aws-ecs-cluster';
export * as dataAwsEcsContainerDefinition from './data-aws-ecs-container-definition';
export * as dataAwsEcsService from './data-aws-ecs-service';
export * as dataAwsEcsTaskDefinition from './data-aws-ecs-task-definition';
export * as dataAwsEcsTaskExecution from './data-aws-ecs-task-execution';
export * as dataAwsEfsAccessPoint from './data-aws-efs-access-point';
export * as dataAwsEfsAccessPoints from './data-aws-efs-access-points';
export * as dataAwsEfsFileSystem from './data-aws-efs-file-system';
export * as dataAwsEfsMountTarget from './data-aws-efs-mount-target';
export * as dataAwsEip from './data-aws-eip';
export * as dataAwsEips from './data-aws-eips';
export * as dataAwsEksAccessEntry from './data-aws-eks-access-entry';
export * as dataAwsEksAddon from './data-aws-eks-addon';
export * as dataAwsEksAddonVersion from './data-aws-eks-addon-version';
export * as dataAwsEksCluster from './data-aws-eks-cluster';
export * as dataAwsEksClusterAuth from './data-aws-eks-cluster-auth';
export * as dataAwsEksClusters from './data-aws-eks-clusters';
export * as dataAwsEksNodeGroup from './data-aws-eks-node-group';
export * as dataAwsEksNodeGroups from './data-aws-eks-node-groups';
export * as dataAwsElasticBeanstalkApplication from './data-aws-elastic-beanstalk-application';
export * as dataAwsElasticBeanstalkHostedZone from './data-aws-elastic-beanstalk-hosted-zone';
export * as dataAwsElasticBeanstalkSolutionStack from './data-aws-elastic-beanstalk-solution-stack';
export * as dataAwsElasticacheCluster from './data-aws-elasticache-cluster';
export * as dataAwsElasticacheReplicationGroup from './data-aws-elasticache-replication-group';
export * as dataAwsElasticacheSubnetGroup from './data-aws-elasticache-subnet-group';
export * as dataAwsElasticacheUser from './data-aws-elasticache-user';
export * as dataAwsElasticsearchDomain from './data-aws-elasticsearch-domain';
export * as dataAwsElb from './data-aws-elb';
export * as dataAwsElbHostedZoneId from './data-aws-elb-hosted-zone-id';
export * as dataAwsElbServiceAccount from './data-aws-elb-service-account';
export * as dataAwsEmrReleaseLabels from './data-aws-emr-release-labels';
export * as dataAwsEmrSupportedInstanceTypes from './data-aws-emr-supported-instance-types';
export * as dataAwsEmrcontainersVirtualCluster from './data-aws-emrcontainers-virtual-cluster';
export * as dataAwsFsxOntapFileSystem from './data-aws-fsx-ontap-file-system';
export * as dataAwsFsxOntapStorageVirtualMachine from './data-aws-fsx-ontap-storage-virtual-machine';
export * as dataAwsFsxOntapStorageVirtualMachines from './data-aws-fsx-ontap-storage-virtual-machines';
export * as dataAwsFsxOpenzfsSnapshot from './data-aws-fsx-openzfs-snapshot';
export * as dataAwsFsxWindowsFileSystem from './data-aws-fsx-windows-file-system';
export * as dataAwsGlobalacceleratorAccelerator from './data-aws-globalaccelerator-accelerator';
export * as dataAwsGlobalacceleratorCustomRoutingAccelerator from './data-aws-globalaccelerator-custom-routing-accelerator';
export * as dataAwsGlueCatalogTable from './data-aws-glue-catalog-table';
export * as dataAwsGlueConnection from './data-aws-glue-connection';
export * as dataAwsGlueDataCatalogEncryptionSettings from './data-aws-glue-data-catalog-encryption-settings';
export * as dataAwsGlueScript from './data-aws-glue-script';
export * as dataAwsGrafanaWorkspace from './data-aws-grafana-workspace';
export * as dataAwsGuarddutyDetector from './data-aws-guardduty-detector';
export * as dataAwsGuarddutyFindingIds from './data-aws-guardduty-finding-ids';
export * as dataAwsIamAccessKeys from './data-aws-iam-access-keys';
export * as dataAwsIamAccountAlias from './data-aws-iam-account-alias';
export * as dataAwsIamGroup from './data-aws-iam-group';
export * as dataAwsIamInstanceProfile from './data-aws-iam-instance-profile';
export * as dataAwsIamInstanceProfiles from './data-aws-iam-instance-profiles';
export * as dataAwsIamOpenidConnectProvider from './data-aws-iam-openid-connect-provider';
export * as dataAwsIamPolicy from './data-aws-iam-policy';
export * as dataAwsIamPolicyDocument from './data-aws-iam-policy-document';
export * as dataAwsIamPrincipalPolicySimulation from './data-aws-iam-principal-policy-simulation';
export * as dataAwsIamRole from './data-aws-iam-role';
export * as dataAwsIamRoles from './data-aws-iam-roles';
export * as dataAwsIamSamlProvider from './data-aws-iam-saml-provider';
export * as dataAwsIamServerCertificate from './data-aws-iam-server-certificate';
export * as dataAwsIamSessionContext from './data-aws-iam-session-context';
export * as dataAwsIamUser from './data-aws-iam-user';
export * as dataAwsIamUserSshKey from './data-aws-iam-user-ssh-key';
export * as dataAwsIamUsers from './data-aws-iam-users';
export * as dataAwsIdentitystoreGroup from './data-aws-identitystore-group';
export * as dataAwsIdentitystoreGroups from './data-aws-identitystore-groups';
export * as dataAwsIdentitystoreUser from './data-aws-identitystore-user';
export * as dataAwsImagebuilderComponent from './data-aws-imagebuilder-component';
export * as dataAwsImagebuilderComponents from './data-aws-imagebuilder-components';
export * as dataAwsImagebuilderContainerRecipe from './data-aws-imagebuilder-container-recipe';
export * as dataAwsImagebuilderContainerRecipes from './data-aws-imagebuilder-container-recipes';
export * as dataAwsImagebuilderDistributionConfiguration from './data-aws-imagebuilder-distribution-configuration';
export * as dataAwsImagebuilderDistributionConfigurations from './data-aws-imagebuilder-distribution-configurations';
export * as dataAwsImagebuilderImage from './data-aws-imagebuilder-image';
export * as dataAwsImagebuilderImagePipeline from './data-aws-imagebuilder-image-pipeline';
export * as dataAwsImagebuilderImagePipelines from './data-aws-imagebuilder-image-pipelines';
export * as dataAwsImagebuilderImageRecipe from './data-aws-imagebuilder-image-recipe';
export * as dataAwsImagebuilderImageRecipes from './data-aws-imagebuilder-image-recipes';
export * as dataAwsImagebuilderInfrastructureConfiguration from './data-aws-imagebuilder-infrastructure-configuration';
export * as dataAwsImagebuilderInfrastructureConfigurations from './data-aws-imagebuilder-infrastructure-configurations';
export * as dataAwsInspectorRulesPackages from './data-aws-inspector-rules-packages';
export * as dataAwsInstance from './data-aws-instance';
export * as dataAwsInstances from './data-aws-instances';
export * as dataAwsInternetGateway from './data-aws-internet-gateway';
export * as dataAwsIotEndpoint from './data-aws-iot-endpoint';
export * as dataAwsIotRegistrationCode from './data-aws-iot-registration-code';
export * as dataAwsIpRanges from './data-aws-ip-ranges';
export * as dataAwsIvsStreamKey from './data-aws-ivs-stream-key';
export * as dataAwsKendraExperience from './data-aws-kendra-experience';
export * as dataAwsKendraFaq from './data-aws-kendra-faq';
export * as dataAwsKendraIndex from './data-aws-kendra-index';
export * as dataAwsKendraQuerySuggestionsBlockList from './data-aws-kendra-query-suggestions-block-list';
export * as dataAwsKendraThesaurus from './data-aws-kendra-thesaurus';
export * as dataAwsKeyPair from './data-aws-key-pair';
export * as dataAwsKinesisFirehoseDeliveryStream from './data-aws-kinesis-firehose-delivery-stream';
export * as dataAwsKinesisStream from './data-aws-kinesis-stream';
export * as dataAwsKinesisStreamConsumer from './data-aws-kinesis-stream-consumer';
export * as dataAwsKmsAlias from './data-aws-kms-alias';
export * as dataAwsKmsCiphertext from './data-aws-kms-ciphertext';
export * as dataAwsKmsCustomKeyStore from './data-aws-kms-custom-key-store';
export * as dataAwsKmsKey from './data-aws-kms-key';
export * as dataAwsKmsPublicKey from './data-aws-kms-public-key';
export * as dataAwsKmsSecret from './data-aws-kms-secret';
export * as dataAwsKmsSecrets from './data-aws-kms-secrets';
export * as dataAwsLakeformationDataLakeSettings from './data-aws-lakeformation-data-lake-settings';
export * as dataAwsLakeformationPermissions from './data-aws-lakeformation-permissions';
export * as dataAwsLakeformationResource from './data-aws-lakeformation-resource';
export * as dataAwsLambdaAlias from './data-aws-lambda-alias';
export * as dataAwsLambdaCodeSigningConfig from './data-aws-lambda-code-signing-config';
export * as dataAwsLambdaFunction from './data-aws-lambda-function';
export * as dataAwsLambdaFunctionUrl from './data-aws-lambda-function-url';
export * as dataAwsLambdaFunctions from './data-aws-lambda-functions';
export * as dataAwsLambdaInvocation from './data-aws-lambda-invocation';
export * as dataAwsLambdaLayerVersion from './data-aws-lambda-layer-version';
export * as dataAwsLaunchConfiguration from './data-aws-launch-configuration';
export * as dataAwsLaunchTemplate from './data-aws-launch-template';
export * as dataAwsLb from './data-aws-lb';
export * as dataAwsLbHostedZoneId from './data-aws-lb-hosted-zone-id';
export * as dataAwsLbListener from './data-aws-lb-listener';
export * as dataAwsLbTargetGroup from './data-aws-lb-target-group';
export * as dataAwsLbTrustStore from './data-aws-lb-trust-store';
export * as dataAwsLbs from './data-aws-lbs';
export * as dataAwsLexBot from './data-aws-lex-bot';
export * as dataAwsLexBotAlias from './data-aws-lex-bot-alias';
export * as dataAwsLexIntent from './data-aws-lex-intent';
export * as dataAwsLexSlotType from './data-aws-lex-slot-type';
export * as dataAwsLicensemanagerGrants from './data-aws-licensemanager-grants';
export * as dataAwsLicensemanagerReceivedLicense from './data-aws-licensemanager-received-license';
export * as dataAwsLicensemanagerReceivedLicenses from './data-aws-licensemanager-received-licenses';
export * as dataAwsLocationGeofenceCollection from './data-aws-location-geofence-collection';
export * as dataAwsLocationMap from './data-aws-location-map';
export * as dataAwsLocationPlaceIndex from './data-aws-location-place-index';
export * as dataAwsLocationRouteCalculator from './data-aws-location-route-calculator';
export * as dataAwsLocationTracker from './data-aws-location-tracker';
export * as dataAwsLocationTrackerAssociation from './data-aws-location-tracker-association';
export * as dataAwsLocationTrackerAssociations from './data-aws-location-tracker-associations';
export * as dataAwsMediaConvertQueue from './data-aws-media-convert-queue';
export * as dataAwsMedialiveInput from './data-aws-medialive-input';
export * as dataAwsMemorydbAcl from './data-aws-memorydb-acl';
export * as dataAwsMemorydbCluster from './data-aws-memorydb-cluster';
export * as dataAwsMemorydbParameterGroup from './data-aws-memorydb-parameter-group';
export * as dataAwsMemorydbSnapshot from './data-aws-memorydb-snapshot';
export * as dataAwsMemorydbSubnetGroup from './data-aws-memorydb-subnet-group';
export * as dataAwsMemorydbUser from './data-aws-memorydb-user';
export * as dataAwsMqBroker from './data-aws-mq-broker';
export * as dataAwsMqBrokerEngineTypes from './data-aws-mq-broker-engine-types';
export * as dataAwsMqBrokerInstanceTypeOfferings from './data-aws-mq-broker-instance-type-offerings';
export * as dataAwsMskBootstrapBrokers from './data-aws-msk-bootstrap-brokers';
export * as dataAwsMskBrokerNodes from './data-aws-msk-broker-nodes';
export * as dataAwsMskCluster from './data-aws-msk-cluster';
export * as dataAwsMskConfiguration from './data-aws-msk-configuration';
export * as dataAwsMskKafkaVersion from './data-aws-msk-kafka-version';
export * as dataAwsMskVpcConnection from './data-aws-msk-vpc-connection';
export * as dataAwsMskconnectConnector from './data-aws-mskconnect-connector';
export * as dataAwsMskconnectCustomPlugin from './data-aws-mskconnect-custom-plugin';
export * as dataAwsMskconnectWorkerConfiguration from './data-aws-mskconnect-worker-configuration';
export * as dataAwsNatGateway from './data-aws-nat-gateway';
export * as dataAwsNatGateways from './data-aws-nat-gateways';
export * as dataAwsNeptuneEngineVersion from './data-aws-neptune-engine-version';
export * as dataAwsNeptuneOrderableDbInstance from './data-aws-neptune-orderable-db-instance';
export * as dataAwsNetworkAcls from './data-aws-network-acls';
export * as dataAwsNetworkInterface from './data-aws-network-interface';
export * as dataAwsNetworkInterfaces from './data-aws-network-interfaces';
export * as dataAwsNetworkfirewallFirewall from './data-aws-networkfirewall-firewall';
export * as dataAwsNetworkfirewallFirewallPolicy from './data-aws-networkfirewall-firewall-policy';
export * as dataAwsNetworkfirewallResourcePolicy from './data-aws-networkfirewall-resource-policy';
export * as dataAwsNetworkmanagerConnection from './data-aws-networkmanager-connection';
export * as dataAwsNetworkmanagerConnections from './data-aws-networkmanager-connections';
export * as dataAwsNetworkmanagerCoreNetworkPolicyDocument from './data-aws-networkmanager-core-network-policy-document';
export * as dataAwsNetworkmanagerDevice from './data-aws-networkmanager-device';
export * as dataAwsNetworkmanagerDevices from './data-aws-networkmanager-devices';
export * as dataAwsNetworkmanagerGlobalNetwork from './data-aws-networkmanager-global-network';
export * as dataAwsNetworkmanagerGlobalNetworks from './data-aws-networkmanager-global-networks';
export * as dataAwsNetworkmanagerLink from './data-aws-networkmanager-link';
export * as dataAwsNetworkmanagerLinks from './data-aws-networkmanager-links';
export * as dataAwsNetworkmanagerSite from './data-aws-networkmanager-site';
export * as dataAwsNetworkmanagerSites from './data-aws-networkmanager-sites';
export * as dataAwsOamLink from './data-aws-oam-link';
export * as dataAwsOamLinks from './data-aws-oam-links';
export * as dataAwsOamSink from './data-aws-oam-sink';
export * as dataAwsOamSinks from './data-aws-oam-sinks';
export * as dataAwsOpensearchDomain from './data-aws-opensearch-domain';
export * as dataAwsOpensearchserverlessAccessPolicy from './data-aws-opensearchserverless-access-policy';
export * as dataAwsOpensearchserverlessCollection from './data-aws-opensearchserverless-collection';
export * as dataAwsOpensearchserverlessLifecyclePolicy from './data-aws-opensearchserverless-lifecycle-policy';
export * as dataAwsOpensearchserverlessSecurityConfig from './data-aws-opensearchserverless-security-config';
export * as dataAwsOpensearchserverlessSecurityPolicy from './data-aws-opensearchserverless-security-policy';
export * as dataAwsOpensearchserverlessVpcEndpoint from './data-aws-opensearchserverless-vpc-endpoint';
export * as dataAwsOrganizationsDelegatedAdministrators from './data-aws-organizations-delegated-administrators';
export * as dataAwsOrganizationsDelegatedServices from './data-aws-organizations-delegated-services';
export * as dataAwsOrganizationsOrganization from './data-aws-organizations-organization';
export * as dataAwsOrganizationsOrganizationalUnit from './data-aws-organizations-organizational-unit';
export * as dataAwsOrganizationsOrganizationalUnitChildAccounts from './data-aws-organizations-organizational-unit-child-accounts';
export * as dataAwsOrganizationsOrganizationalUnitDescendantAccounts from './data-aws-organizations-organizational-unit-descendant-accounts';
export * as dataAwsOrganizationsOrganizationalUnits from './data-aws-organizations-organizational-units';
export * as dataAwsOrganizationsPolicies from './data-aws-organizations-policies';
export * as dataAwsOrganizationsPoliciesForTarget from './data-aws-organizations-policies-for-target';
export * as dataAwsOrganizationsPolicy from './data-aws-organizations-policy';
export * as dataAwsOrganizationsResourceTags from './data-aws-organizations-resource-tags';
export * as dataAwsOutpostsAsset from './data-aws-outposts-asset';
export * as dataAwsOutpostsAssets from './data-aws-outposts-assets';
export * as dataAwsOutpostsOutpost from './data-aws-outposts-outpost';
export * as dataAwsOutpostsOutpostInstanceType from './data-aws-outposts-outpost-instance-type';
export * as dataAwsOutpostsOutpostInstanceTypes from './data-aws-outposts-outpost-instance-types';
export * as dataAwsOutpostsOutposts from './data-aws-outposts-outposts';
export * as dataAwsOutpostsSite from './data-aws-outposts-site';
export * as dataAwsOutpostsSites from './data-aws-outposts-sites';
export * as dataAwsPartition from './data-aws-partition';
export * as dataAwsPollyVoices from './data-aws-polly-voices';
export * as dataAwsPrefixList from './data-aws-prefix-list';
export * as dataAwsPricingProduct from './data-aws-pricing-product';
export * as dataAwsPrometheusWorkspace from './data-aws-prometheus-workspace';
export * as dataAwsPrometheusWorkspaces from './data-aws-prometheus-workspaces';
export * as dataAwsQldbLedger from './data-aws-qldb-ledger';
export * as dataAwsQuicksightDataSet from './data-aws-quicksight-data-set';
export * as dataAwsQuicksightGroup from './data-aws-quicksight-group';
export * as dataAwsQuicksightTheme from './data-aws-quicksight-theme';
export * as dataAwsQuicksightUser from './data-aws-quicksight-user';
export * as dataAwsRamResourceShare from './data-aws-ram-resource-share';
export * as dataAwsRdsCertificate from './data-aws-rds-certificate';
export * as dataAwsRdsCluster from './data-aws-rds-cluster';
export * as dataAwsRdsClusters from './data-aws-rds-clusters';
export * as dataAwsRdsEngineVersion from './data-aws-rds-engine-version';
export * as dataAwsRdsOrderableDbInstance from './data-aws-rds-orderable-db-instance';
export * as dataAwsRdsReservedInstanceOffering from './data-aws-rds-reserved-instance-offering';
export * as dataAwsRedshiftCluster from './data-aws-redshift-cluster';
export * as dataAwsRedshiftClusterCredentials from './data-aws-redshift-cluster-credentials';
export * as dataAwsRedshiftDataShares from './data-aws-redshift-data-shares';
export * as dataAwsRedshiftOrderableCluster from './data-aws-redshift-orderable-cluster';
export * as dataAwsRedshiftProducerDataShares from './data-aws-redshift-producer-data-shares';
export * as dataAwsRedshiftServiceAccount from './data-aws-redshift-service-account';
export * as dataAwsRedshiftSubnetGroup from './data-aws-redshift-subnet-group';
export * as dataAwsRedshiftserverlessCredentials from './data-aws-redshiftserverless-credentials';
export * as dataAwsRedshiftserverlessNamespace from './data-aws-redshiftserverless-namespace';
export * as dataAwsRedshiftserverlessWorkgroup from './data-aws-redshiftserverless-workgroup';
export * as dataAwsRegion from './data-aws-region';
export * as dataAwsRegions from './data-aws-regions';
export * as dataAwsResourceexplorer2Search from './data-aws-resourceexplorer2-search';
export * as dataAwsResourcegroupstaggingapiResources from './data-aws-resourcegroupstaggingapi-resources';
export * as dataAwsRoute from './data-aws-route';
export * as dataAwsRoute53DelegationSet from './data-aws-route53-delegation-set';
export * as dataAwsRoute53ResolverEndpoint from './data-aws-route53-resolver-endpoint';
export * as dataAwsRoute53ResolverFirewallConfig from './data-aws-route53-resolver-firewall-config';
export * as dataAwsRoute53ResolverFirewallDomainList from './data-aws-route53-resolver-firewall-domain-list';
export * as dataAwsRoute53ResolverFirewallRuleGroup from './data-aws-route53-resolver-firewall-rule-group';
export * as dataAwsRoute53ResolverFirewallRuleGroupAssociation from './data-aws-route53-resolver-firewall-rule-group-association';
export * as dataAwsRoute53ResolverFirewallRules from './data-aws-route53-resolver-firewall-rules';
export * as dataAwsRoute53ResolverQueryLogConfig from './data-aws-route53-resolver-query-log-config';
export * as dataAwsRoute53ResolverRule from './data-aws-route53-resolver-rule';
export * as dataAwsRoute53ResolverRules from './data-aws-route53-resolver-rules';
export * as dataAwsRoute53TrafficPolicyDocument from './data-aws-route53-traffic-policy-document';
export * as dataAwsRoute53Zone from './data-aws-route53-zone';
export * as dataAwsRouteTable from './data-aws-route-table';
export * as dataAwsRouteTables from './data-aws-route-tables';
export * as dataAwsS3AccountPublicAccessBlock from './data-aws-s3-account-public-access-block';
export * as dataAwsS3Bucket from './data-aws-s3-bucket';
export * as dataAwsS3BucketObject from './data-aws-s3-bucket-object';
export * as dataAwsS3BucketObjects from './data-aws-s3-bucket-objects';
export * as dataAwsS3BucketPolicy from './data-aws-s3-bucket-policy';
export * as dataAwsS3DirectoryBuckets from './data-aws-s3-directory-buckets';
export * as dataAwsS3Object from './data-aws-s3-object';
export * as dataAwsS3Objects from './data-aws-s3-objects';
export * as dataAwsS3ControlMultiRegionAccessPoint from './data-aws-s3control-multi-region-access-point';
export * as dataAwsSagemakerPrebuiltEcrImage from './data-aws-sagemaker-prebuilt-ecr-image';
export * as dataAwsSecretsmanagerRandomPassword from './data-aws-secretsmanager-random-password';
export * as dataAwsSecretsmanagerSecret from './data-aws-secretsmanager-secret';
export * as dataAwsSecretsmanagerSecretRotation from './data-aws-secretsmanager-secret-rotation';
export * as dataAwsSecretsmanagerSecretVersion from './data-aws-secretsmanager-secret-version';
export * as dataAwsSecretsmanagerSecrets from './data-aws-secretsmanager-secrets';
export * as dataAwsSecurityGroup from './data-aws-security-group';
export * as dataAwsSecurityGroups from './data-aws-security-groups';
export * as dataAwsServerlessapplicationrepositoryApplication from './data-aws-serverlessapplicationrepository-application';
export * as dataAwsService from './data-aws-service';
export * as dataAwsServiceDiscoveryDnsNamespace from './data-aws-service-discovery-dns-namespace';
export * as dataAwsServiceDiscoveryHttpNamespace from './data-aws-service-discovery-http-namespace';
export * as dataAwsServiceDiscoveryService from './data-aws-service-discovery-service';
export * as dataAwsServicecatalogConstraint from './data-aws-servicecatalog-constraint';
export * as dataAwsServicecatalogLaunchPaths from './data-aws-servicecatalog-launch-paths';
export * as dataAwsServicecatalogPortfolio from './data-aws-servicecatalog-portfolio';
export * as dataAwsServicecatalogPortfolioConstraints from './data-aws-servicecatalog-portfolio-constraints';
export * as dataAwsServicecatalogProduct from './data-aws-servicecatalog-product';
export * as dataAwsServicecatalogProvisioningArtifacts from './data-aws-servicecatalog-provisioning-artifacts';
export * as dataAwsServicecatalogappregistryApplication from './data-aws-servicecatalogappregistry-application';
export * as dataAwsServicequotasService from './data-aws-servicequotas-service';
export * as dataAwsServicequotasServiceQuota from './data-aws-servicequotas-service-quota';
export * as dataAwsServicequotasTemplates from './data-aws-servicequotas-templates';
export * as dataAwsSesActiveReceiptRuleSet from './data-aws-ses-active-receipt-rule-set';
export * as dataAwsSesDomainIdentity from './data-aws-ses-domain-identity';
export * as dataAwsSesEmailIdentity from './data-aws-ses-email-identity';
export * as dataAwsSesv2ConfigurationSet from './data-aws-sesv2-configuration-set';
export * as dataAwsSesv2DedicatedIpPool from './data-aws-sesv2-dedicated-ip-pool';
export * as dataAwsSesv2EmailIdentity from './data-aws-sesv2-email-identity';
export * as dataAwsSesv2EmailIdentityMailFromAttributes from './data-aws-sesv2-email-identity-mail-from-attributes';
export * as dataAwsSfnActivity from './data-aws-sfn-activity';
export * as dataAwsSfnAlias from './data-aws-sfn-alias';
export * as dataAwsSfnStateMachine from './data-aws-sfn-state-machine';
export * as dataAwsSfnStateMachineVersions from './data-aws-sfn-state-machine-versions';
export * as dataAwsSignerSigningJob from './data-aws-signer-signing-job';
export * as dataAwsSignerSigningProfile from './data-aws-signer-signing-profile';
export * as dataAwsSnsTopic from './data-aws-sns-topic';
export * as dataAwsSqsQueue from './data-aws-sqs-queue';
export * as dataAwsSqsQueues from './data-aws-sqs-queues';
export * as dataAwsSsmDocument from './data-aws-ssm-document';
export * as dataAwsSsmInstances from './data-aws-ssm-instances';
export * as dataAwsSsmMaintenanceWindows from './data-aws-ssm-maintenance-windows';
export * as dataAwsSsmParameter from './data-aws-ssm-parameter';
export * as dataAwsSsmParametersByPath from './data-aws-ssm-parameters-by-path';
export * as dataAwsSsmPatchBaseline from './data-aws-ssm-patch-baseline';
export * as dataAwsSsmcontactsContact from './data-aws-ssmcontacts-contact';
export * as dataAwsSsmcontactsContactChannel from './data-aws-ssmcontacts-contact-channel';
export * as dataAwsSsmcontactsPlan from './data-aws-ssmcontacts-plan';
export * as dataAwsSsmcontactsRotation from './data-aws-ssmcontacts-rotation';
export * as dataAwsSsmincidentsReplicationSet from './data-aws-ssmincidents-replication-set';
export * as dataAwsSsmincidentsResponsePlan from './data-aws-ssmincidents-response-plan';
export * as dataAwsSsoadminApplication from './data-aws-ssoadmin-application';
export * as dataAwsSsoadminApplicationAssignments from './data-aws-ssoadmin-application-assignments';
export * as dataAwsSsoadminApplicationProviders from './data-aws-ssoadmin-application-providers';
export * as dataAwsSsoadminInstances from './data-aws-ssoadmin-instances';
export * as dataAwsSsoadminPermissionSet from './data-aws-ssoadmin-permission-set';
export * as dataAwsSsoadminPrincipalApplicationAssignments from './data-aws-ssoadmin-principal-application-assignments';
export * as dataAwsStoragegatewayLocalDisk from './data-aws-storagegateway-local-disk';
export * as dataAwsSubnet from './data-aws-subnet';
export * as dataAwsSubnets from './data-aws-subnets';
export * as dataAwsTransferServer from './data-aws-transfer-server';
export * as dataAwsVerifiedpermissionsPolicyStore from './data-aws-verifiedpermissions-policy-store';
export * as dataAwsVpc from './data-aws-vpc';
export * as dataAwsVpcDhcpOptions from './data-aws-vpc-dhcp-options';
export * as dataAwsVpcEndpoint from './data-aws-vpc-endpoint';
export * as dataAwsVpcEndpointService from './data-aws-vpc-endpoint-service';
export * as dataAwsVpcIpamPool from './data-aws-vpc-ipam-pool';
export * as dataAwsVpcIpamPoolCidrs from './data-aws-vpc-ipam-pool-cidrs';
export * as dataAwsVpcIpamPools from './data-aws-vpc-ipam-pools';
export * as dataAwsVpcIpamPreviewNextCidr from './data-aws-vpc-ipam-preview-next-cidr';
export * as dataAwsVpcPeeringConnection from './data-aws-vpc-peering-connection';
export * as dataAwsVpcPeeringConnections from './data-aws-vpc-peering-connections';
export * as dataAwsVpcSecurityGroupRule from './data-aws-vpc-security-group-rule';
export * as dataAwsVpcSecurityGroupRules from './data-aws-vpc-security-group-rules';
export * as dataAwsVpclatticeAuthPolicy from './data-aws-vpclattice-auth-policy';
export * as dataAwsVpclatticeListener from './data-aws-vpclattice-listener';
export * as dataAwsVpclatticeResourcePolicy from './data-aws-vpclattice-resource-policy';
export * as dataAwsVpclatticeService from './data-aws-vpclattice-service';
export * as dataAwsVpclatticeServiceNetwork from './data-aws-vpclattice-service-network';
export * as dataAwsVpcs from './data-aws-vpcs';
export * as dataAwsVpnGateway from './data-aws-vpn-gateway';
export * as dataAwsWafIpset from './data-aws-waf-ipset';
export * as dataAwsWafRateBasedRule from './data-aws-waf-rate-based-rule';
export * as dataAwsWafRule from './data-aws-waf-rule';
export * as dataAwsWafSubscribedRuleGroup from './data-aws-waf-subscribed-rule-group';
export * as dataAwsWafWebAcl from './data-aws-waf-web-acl';
export * as dataAwsWafregionalIpset from './data-aws-wafregional-ipset';
export * as dataAwsWafregionalRateBasedRule from './data-aws-wafregional-rate-based-rule';
export * as dataAwsWafregionalRule from './data-aws-wafregional-rule';
export * as dataAwsWafregionalSubscribedRuleGroup from './data-aws-wafregional-subscribed-rule-group';
export * as dataAwsWafregionalWebAcl from './data-aws-wafregional-web-acl';
export * as dataAwsWafv2IpSet from './data-aws-wafv2-ip-set';
export * as dataAwsWafv2RegexPatternSet from './data-aws-wafv2-regex-pattern-set';
export * as dataAwsWafv2RuleGroup from './data-aws-wafv2-rule-group';
export * as dataAwsWafv2WebAcl from './data-aws-wafv2-web-acl';
export * as dataAwsWorkspacesBundle from './data-aws-workspaces-bundle';
export * as dataAwsWorkspacesDirectory from './data-aws-workspaces-directory';
export * as dataAwsWorkspacesImage from './data-aws-workspaces-image';
export * as dataAwsWorkspacesWorkspace from './data-aws-workspaces-workspace';
export * as provider from './provider';
